SystemOrganization addCategory: #'Sight-Cst-Analyzing'!
SystemOrganization addCategory: #'Sight-Cst-Browser'!
SystemOrganization addCategory: #'Sight-Cst-Coverage'!
SystemOrganization addCategory: #'Sight-Cst-Distribution'!
SystemOrganization addCategory: #'Sight-Cst-DistributionTests'!
SystemOrganization addCategory: #'Sight-Cst-Install'!
SystemOrganization addCategory: #'Sight-Cst'!
SystemOrganization addCategory: #'Sight-Cst-Tests'!
SystemOrganization addCategory: #'Sight-Cst-Text'!

OBMetagraphBuilder subclass: #SCMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Browser'!

!SCMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 17:55:37.789'!
createMethodMetaNode
	| methodMetaNode testMetaNode |
	testMetaNode := OBMetaNode named: #CoveringTestCases.
	methodMetaNode := OBMetaNode named: #Method.
	methodMetaNode childAt: #coveringTestMethods put: testMetaNode.
	^ methodMetaNode! !

!SCMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 17:52:34.335'!
methodMetaNode
 	^ (self metaNodes
		at: #Method
		ifAbsentPut: [OBMetaNode named: #Method])! !

!SCMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 17:56:48.319'!
populateMethodNode
	| testMetaNode |
	super populateMethodNode.
	testMetaNode := OBMetaNode named: #CoveringTestCases.
	self methodMetaNode
		childAt: #coveringTestMethods put: testMetaNode.
! !

STracingTestCase subclass: #SCoverageTestCase
	instanceVariableNames: 'csTestRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

SCoverageTestCase subclass: #SAsyncAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/20/2010 22:54:27.874'!
testRunInBackground

	SAsyncExampleTest resetCollectedMessages.
	self should: [ SAsyncExampleTest collectedMessagesAsString = '' ].
	
	self csTestRunner runSuite: SAsyncExampleTest exampleSuite.
	self should: [ SAsyncExampleTest collectedMessagesAsString = 'Hello' ].
	
	SAsyncExampleTest resetCollectedMessages.
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: SAsyncExampleTest backgroundExampleSuite.
	(Delay forMilliseconds: 200) wait.
	SCoverageTestRunner sourceCodeAccessMonitor critical: [ 
		SAsyncExampleTest addMessage: 'World'. ].
	self should: [ SAsyncExampleTest collectedMessagesAsString = 'HelloWorld' ].
	self csTestRunner disableRunningTestsInBackground.! !

!SAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:09.981'!
testRunningExampleSuite
	SAsyncExampleTest resetCollectedMessages.
	self csTestRunner runSuite: (SAsyncExampleTest exampleSuite).
	self should: [SAsyncExampleTest collectedMessagesAsString = 'Hello']. ! !

SCoverageTestCase subclass: #SBasicTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:35:09.172'!
testConcreteClassCoverage
	self deny: self exampleMethod hasMethodExtension.
	
	self tracePackage: self tbPackage.
	self runTbTests.
	
	self assert: [ self exampleMethod hasCoveringTestMethods ].
	self deny: [ (self exampleMethod coveringTestMethodsWhenReceiverWasOfKind: STbPerson) size = 0 ].! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:02:10.642'!
testCoverageApi
	| testMethod method |
	method := (STbPerson >> #firstname) clientMethod.
	testMethod := (STbPersonTest >> #testFirstnameAccessors) clientMethod.
	method 
		resetAllCoverageData;
		methodExtension: SNonTestMethodExtension new.
	method cstMethodExtension clientMethod: method.
		
	testMethod 
		resetAllCoverageData;
		methodExtension: STestMethodExtension new.
	testMethod cstMethodExtension clientMethod: testMethod.
	
	testMethod called: method receiver: nil.
	
	self should: [method hasCoveringTestMethods].
	self shouldnt: [testMethod hasCoveringTestMethods].
	self should: [method coveringTestMethods size = 1].
	self should: [method fixedTestMethods size = 0].
	self should: [method coveringAndNotFixedTestMethods size = 1].
	self should: [testMethod coveredMethods includes: method].
	self should: [testMethod coveredMethodsStatistics isEmpty not].
	
	method 
		resetAllCoverageData;
	 	resetMethodExtension.
	testMethod 
		resetAllCoverageData;
		resetMethodExtension.! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:35:09.158'!
testRetrievingTestsForMethod
	self tracePackage: self tbPackage.
	self runTbTests.
	self assert: (self exampleMethod coveringTestMethods includes: STbPersonTest >> #testFirstnameAccessors).! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:35:09.165'!
testRetrievingTestsForQuickReturnMethod
	self tracePackage: self tbPackage.
	self runTbTests.
	self assert: ((STbPerson>>#firstname) coveringTestMethods includes: STbPersonTest >> #testFirstnameAccessors).! !

!SCoverageTestCase class methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 18:30:44.675'!
shouldInheritSelectors
	^ false! !

!SCoverageTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/20/2010 19:10:17.53'!
createInstrumentor
	^ SInstrumentor wrappingAndCreateExtensionsWith: self csTestRunner createExtensionBlock.! !

!SCoverageTestCase methodsFor: 'accessing' stamp: 'bs 7/20/2010 22:54:27.907'!
csTestRunner
	^ csTestRunner ifNil: [ csTestRunner := SCoverageTestRunner new ]! !

!SCoverageTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:37:51.8'!
runTbTests
	self runTestMethods: self tbTestMethods.! !

!SCoverageTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:37:29.852'!
runTestMethods: testMethods
	self csTestRunner runAndTraceTestMethods: testMethods.! !

SMethodExtension subclass: #SCstMethodExtension
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SCstMethodExtension class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:32:28.733'!
instance
	^ Instance ifNil: [ Instance := super new ]! !

!SCstMethodExtension class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:32:16.96'!
new
	^ (self = SCstMethodExtension) 
		ifTrue: [ self instance ]
		ifFalse: [ super new ]! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:59:16.448'!
calledMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:38.556'!
coveredMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:48.841'!
coveredMethodsStatistics
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:57:48.206'!
coveringAndNotFixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:57:30.543'!
coveringTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:04.25'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	^ Array empty! !

!SCstMethodExtension methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:11:21.749'!
doesNotUnderstand: aMessage
	(self class subclasses anySatisfy: [ :c | c canUnderstand: aMessage selector ])
		ifFalse: [ self error: 'cst method extensions fail to support this message' ]! !

!SCstMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/18/2010 12:15:50.529'!
fixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:55:23.83'!
hasCoveringTestMethods
	^ false! !

!SCstMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/21/2010 15:43:07.799'!
hasFixedTestMethods
	^ false! !

!SCstMethodExtension methodsFor: 'accessing' stamp: 'bs 7/5/2010 08:35:48.717'!
pvtCodeSightMonitor
	^ SCodeSight sourceCodeMonitor! !

SCstMethodExtension subclass: #SNonTestMethodExtension
	instanceVariableNames: 'coverageTestRunner coveringTestMethods fixedTestMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/20/2010 17:38:57.471'!
beforeMethod

	self flag: #rkrk. "for benchmarking"
	coverageTestRunner runningTestMethod
		ifNotNilDo: [ :runningTestMethod |
			runningTestMethod called: self clientMethod ]! !

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/20/2010 17:39:02.548'!
beforeMethodWithReceiver: anObject 
	coverageTestRunner runningTestMethod
		ifNotNilDo: [ :runningTestMethod |
			self calledBy: runningTestMethod receiverClass: anObject class ]! !

!SNonTestMethodExtension methodsFor: 'coverage tracing' stamp: 'bs 7/4/2010 21:20:00.58'!
calledBy: aTestMethod receiverClass: aClass 
	self pvtCoveringTestMethods add: aTestMethod.
	aTestMethod privateCovered: clientMethod withReceiverClass: aClass! !

!SNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 7/20/2010 17:34:14.758'!
coverageTestRunner
	^ coverageTestRunner! !

!SNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 7/20/2010 17:34:14.768'!
coverageTestRunner: anObject
	coverageTestRunner := anObject! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringAndNotFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtCoveringTestMethods copy.
		"fixed link might be established and coverage not yet"
		result removeAllFoundIn: self pvtFixedTestMethods ].
	^ result ! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods copy ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:32'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods 
			select: [ :testMethod | 
				(testMethod privateStatisticsForCoveredMethod: self unwrappedMethod) 
					receiverClasses includes: aClass ] ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtFixedTestMethods copy ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixes: aCompiledTestMethod 
	self fixesAll: {aCompiledTestMethod}! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:10:15.679'!
fixesAll: compiledTestMethods 
	self pvtCodeSightMonitor critical: [
		compiledTestMethods do: [:ea | 
			self pvtFixedTestMethods add: ea.
			ea privateAddMethodThatFixedTest: clientMethod]. ].! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
hasCoveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods isEmpty not ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
hasFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtFixedTestMethods isEmpty not ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:13:19.001'!
initialize
	super initialize.
	coveringTestMethods := KeyedIdentitySet
				keyBlock: [:t1 | t1 scaledIdentityHash]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
privateAddCoveringTestMethod: aCompiledTestMethod
	^ self pvtCoveringTestMethods add: aCompiledTestMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:29'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod ifAbsent: []! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:28:45.848'!
privateRemoveFixedTestMethod: aCompiledTestMethod
	self pvtFixedTestMethods remove: aCompiledTestMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:06:56.071'!
pvtCoveringTestMethods
	^ coveringTestMethods 
		ifNil: [ coveringTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/22/2010 10:15'!
pvtFixedTestMethods
	^ fixedTestMethods 
		ifNil: [fixedTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ]]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetCoveringTestMethods
	coveringTestMethods := nil! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetFixedTestMethods
	fixedTestMethods := nil! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeCoveringTestMethod: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		"the other direction is removed by the sender"
		self privateRemoveCoveringTestMethod: aTestCaseMethod ]! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 8/5/2010 11:23:36.774'!
removeFixedTestMethod: aTestMethod
	self pvtCodeSightMonitor critical: [
		aTestMethod privateRemoveMethodThatFixedTest: clientMethod.
		self pvtFixedTestMethods remove: aTestMethod. ]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		(self pvtFixedTestMethods includes: aTestCaseMethod) ifFalse: [^ self].
		(self pvtCoveringTestMethods includes: aTestCaseMethod) ifTrue: [^ self].
		self pvtFixedTestMethods remove: aTestCaseMethod ]
	! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:10'!
resetAllCoverageData
	self 
		resetCoveringTestMethods;
		resetFixedTestMethods.! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:11'!
resetCoveringTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtCoveringTestMethods do: [:testMethod |
			testMethod privateRemoveCoveredMethod: self unwrappedMethod ].
		self pvtResetCoveringTestMethods ].! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:22:15.215'!
resetFixedTestMethods
	self pvtCodeSightMonitor critical: [
		self fixedTestMethods do: [:ea | 
			ea privateRemoveMethodThatFixedTest: clientMethod ].
		self pvtResetFixedTestMethods ].! !

SCstMethodExtension subclass: #STestMethodExtension
	instanceVariableNames: 'coveredMethodsStatistics calledMethods methodsThatFixedTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:53:25.565'!
called: aCompiledMethod

	self flag: #rkrk. "for benchmarking"
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { }  ]! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:52:43.762'!
called: aCompiledMethod receiver: anObject 
	
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { anObject class }  ].! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:51:41.557'!
called: aCompiledMethod receiverClasses: classes 

	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: classes ].! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:52'!
calledMethods
	^ calledMethods ifNil: [ calledMethods := OrderedIdentityCollection new  ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 8/5/2010 15:24:07.519'!
coveredMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics keys asIdentitySet ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:05'!
coveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics copy ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 4/23/2010 10:34:11.8'!
hasCoveringTestMethods
	^ false! !

!STestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:12:21.388'!
initialize
	super initialize.
	coveredMethodsStatistics := OrderedKeysIdentityDictionary new! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 12:02:07.634'!
methodsThatFixedTest
	^ self pvtCodeSightMonitor critical: [self pvtMethodsThatFixedTest]! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 12:02:46.624'!
privateAddMethodThatFixedTest: aCompiledMethod
	self pvtMethodsThatFixedTest add: aCompiledMethod! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/4/2010 21:19:49.989'!
privateCovered: aCompiledAppMethod withReceiverClass: aClass
	| statistic |
	statistic := self pvtCoveredMethodsStatistics 
				at: aCompiledAppMethod
				ifAbsentPut: [ STestStatistic new ].
	statistic addReceiverClass: aClass.
	self calledMethods add: aCompiledAppMethod.! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:28'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:56:07.343'!
privateRemoveMethodThatFixedTest: aCompiledMethod
	self pvtMethodsThatFixedTest remove: aCompiledMethod ifAbsent: []! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:06'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self pvtCoveredMethodsStatistics at: aCompiledMethod ! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'bs 7/5/2010 11:33:21.544'!
pvtCalled: aCompiledMethod receiverClasses: classes 
	| statistic |
	aCompiledMethod privateAddCoveringTestMethod: self clientMethod.
		
	statistic := self pvtCoveredMethodsStatistics 
			at: aCompiledMethod
			ifAbsentPut: [ STestStatistic new ].
	statistic addReceiverClasses: classes.! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:09:05.391'!
pvtCoveredMethodsStatistics
	^  coveredMethodsStatistics 
		ifNil: [ coveredMethodsStatistics := OrderedKeysIdentityDictionary new ]! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 12:00:50.584'!
pvtMethodsThatFixedTest
	^ methodsThatFixedTest ifNil: [methodsThatFixedTest := IdentitySet new]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtResetCoveredMethodsStatistics
	coveredMethodsStatistics := nil! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:16:22.538'!
pvtResetMethodsThatFixedTest
	methodsThatFixedTest := nil! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
removeCoveredMethod: aCompiledAppMethod
	self pvtCodeSightMonitor critical: [
		self privateRemoveCoveredMethod: aCompiledAppMethod ]! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 8/5/2010 11:20:42.474'!
removeMethodThatFixedTest: aMethod
	self pvtCodeSightMonitor critical: [
		aMethod privateRemoveFixedTestMethod: clientMethod.
		self pvtMethodsThatFixedTest remove: aMethod ifAbsent: [] ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:08'!
resetAllCoverageData
	self resetCoveredMethodsStatistics! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:46'!
resetCoveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: [
		self pvtCoveredMethodsStatistics keysDo: [ :coveredMethod | 
				coveredMethod privateRemoveCoveringTestMethod: self unwrappedMethod. ].
	
		result := self pvtResetCoveredMethodsStatistics. 
		calledMethods := nil ].
	^ result! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:29:08.87'!
resetMethodsThatFixedTest
	self pvtCodeSightMonitor critical: [
		self methodsThatFixedTest do: [:ea | 
			ea privateRemoveFixedTestMethod: clientMethod ].
		self pvtResetMethodsThatFixedTest ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:09'!
statisticsForCoveredMethod: aCompiledMethod 
	| result |
	self pvtCodeSightMonitor critical: [
		result := self privateStatisticsForCoveredMethod: aCompiledMethod  ].
	^ result! !

TestCase subclass: #SBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SBenchmarkTest class methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!SBenchmarkTest methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.884'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := STbPerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.! !

TestCase subclass: #STestResultCopyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-DistributionTests'!

!STestResultCopyTest methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.69'!
testCopy
	| sut aTest theCopy |
	sut := TestResult new.
	aTest := STbPersonTest selector: #testFailing.
	aTest fooBar: 'Hello'.
	self should: [ aTest fooBar = 'Hello' ].
	(sut instVarNamed: 'passed') add: aTest.
	
	theCopy := sut copy.
	self should: [ theCopy passed size = 1 ].
	self should: [ theCopy passed asArray first fooBar = nil ].! !

OBSystemBrowser subclass: #SCBrowser
	instanceVariableNames: 'isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Browser'!

!SCBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 18:08:37.923'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
   	^ (SCMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!SCBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 23:12'!
paneCount
	^ 5! !

!SCBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 17:19:07.545'!
title
	^ 'Sight System Browser'! !

!SCBrowser methodsFor: 'test infos' stamp: 'bs 8/6/2010 17:19:43.728'!
csInfo
	^ SInfo instance! !

!SCBrowser methodsFor: 'debugging into tests' stamp: 'bs 5/4/2009 21:43'!
selectionChanged: announcement
	
	| node testMethod testClass testSelector testSuite |	
	node := announcement node.
	(node isNil not and: [ node isKindOf: OBCoveringTestCaseNode]) ifTrue: [
		testMethod := node testMethod.
		testClass := testMethod methodClass.
		testSelector := testMethod selector.
		testSuite := testClass suiteWithSelectorsMatching: testSelector.
		[
		BreakpointManager installSelfRemovingBreakpointInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector).
		[ testSuite run ] ensure: [ 
			BreakpointManager unInstallInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector). ].
		] forkAt: Processor activePriority.].! !

!SCBrowser methodsFor: 'subscribing' stamp: 'bs 1/14/2010 11:47'!
subscribe
	super subscribe.
	self csInfo addDependent: self.
	self announcer
		observe: OBSelectionChanged send: #selectionChanged: to: self.! !

!SCBrowser methodsFor: 'test infos' stamp: 'bs 1/14/2010 13:06'!
update: aSymbol
	super update: aSymbol.
	(#(newTestResult startTestRun endTestRun) includes: aSymbol) ifFalse: [^ self].
	self announce: OBNodeChanged
	! !

SEventHandler subclass: #SCoverageEventHandler
	instanceVariableNames: 'coverageTestRunner'
	classVariableNames: 'RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SCoverageEventHandler methodsFor: 'system event handling' stamp: 'bs 7/20/2010 23:18:28.911'!
classRemoved: aRemovedEvent
	aRemovedEvent item isTestCaseClass 
		ifTrue: [ 
			aRemovedEvent item testMethods do: [ :ea | 
				self coverageTestRunner testMethodRemoved: ea ] ]! !

!SCoverageEventHandler methodsFor: 'accessing' stamp: 'bs 7/20/2010 23:10:55.523'!
coverageTestRunner
	^ coverageTestRunner! !

!SCoverageEventHandler methodsFor: 'accessing' stamp: 'bs 7/20/2010 23:10:55.533'!
coverageTestRunner: anObject
	coverageTestRunner := anObject! !

!SCoverageEventHandler methodsFor: 'system event handling' stamp: 'bs 8/6/2010 11:55:18.563'!
methodModified: aModifiedEvent
	aModifiedEvent item isTestMethod 
		ifTrue: [ 
			self coverageTestRunner 
				testMethodModifiedFrom: aModifiedEvent oldItem
				to: aModifiedEvent item ]! !

!SCoverageEventHandler methodsFor: 'system event handling' stamp: 'bs 7/20/2010 23:18:21.163'!
methodRemoved: aRemovedEvent
	aRemovedEvent item isTestMethod
		ifTrue: [ 
			self coverageTestRunner testMethodRemoved: aRemovedEvent item ]! !

SEventHandler subclass: #SReplicaCommandCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicaCommandCreator methodsFor: 'system event handling' stamp: 'bs 1/28/2010 21:29:26.234'!
classAdded: anAddedEvent! !

SEventHandler subclass: #SReplicaService
	instanceVariableNames: 'listenSocket servingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:40.695'!
receiveAndProcess: aSocket
	| receivedMessage |
	receivedMessage := SReplicateMessage receiveFrom: aSocket.
	receivedMessage applyCommand.
	self codeSight 
		ifNotNil: [ self codeSight csTestRunner result copy ]! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 08:59:23.349'!
runLoop
	"Run the server's connection accept loop."
	| newConnectionSocket |
	
	[listenSocket isValid]
		whileTrue: 
			[[newConnectionSocket := listenSocket waitForAcceptFor: 10]
				on: ConnectionTimedOut
				do: [:ex | newConnectionSocket := nil].
			 newConnectionSocket isNil
				ifFalse:
					[ self serve: newConnectionSocket ] ]! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:40.687'!
serve: aSocket
	| receivedMessage |
	[aSocket isValid and: [aSocket isConnected] ] 
		whileTrue: [
			aSocket waitForDataIfClosed: [ ].
			receivedMessage := SReplicateMessage receiveFrom: aSocket.
			receivedMessage applyCommand ] 
	! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 16:38:39.339'!
servicePriority
	^ Processor lowIOPriority! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 09:43:23.521'!
startOn: portNumber
	
	listenSocket := Socket newTCP.
	listenSocket listenOn: portNumber backlogSize: 2.
	listenSocket isValid ifFalse: [^self error: 'Could not create server socket'].
	servingProcess := [self runLoop] forkAt: self servicePriority.! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 19:21:28.985'!
stop
	servingProcess terminate.
	listenSocket closeAndDestroy.! !

SEventHandler subclass: #SReplicator
	instanceVariableNames: 'replicaName servicePort clientSocket replicaProcess actorId'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:14.991'!
existsInstanceWithName: aName orPort: anInteger
	^ self instances 
		anySatisfy: [ :aReplicator | 
			(aReplicator replicaName = aName) 
				or: [ aReplicator servicePort = anInteger ] ]! !

!SReplicator class methodsFor: 'class initialization' stamp: 'bs 1/27/2010 22:08:28.259'!
initialize
	" self initialize "
	super initialize.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!SReplicator class methodsFor: 'accessing' stamp: 'bs 2/8/2010 18:14:39.907'!
instances
	" Instances := nil "
	^ Instances ifNil: [ Instances := WeakSet new ]! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 1/27/2010 22:29:37.5'!
new
	self error: 'only use newWithReplicaName: '! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:09.773'!
newMaintenanceReplica
	^ self newMaintenanceReplicaOnPort: 9998.! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:15.342'!
newMaintenanceReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'maintenance'
		servingOnPort: anInteger.! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:49.034'!
newReplicaNamed: aName servingOnPort: anInteger
	(self existsInstanceWithName: aName orPort: anInteger)
		ifTrue: [ self error: ('there already exists a replicated image ',
					'with name: {1} or port: {2}' format: {aName asString. anInteger asString}) ].
	
	^ self instances add: ( 
		super new 
			replicaName: aName; 
			servicePort: anInteger;
			yourself ).
			! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:40.482'!
newTestReplica
	^ self newTestReplicaOnPort: 9999! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:10.667'!
newTestReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'testFeedback'
		servingOnPort: anInteger! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:04:59.818'!
remove: aReplicator
	self instances remove: aReplicator ifAbsent: []! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:02:26.951'!
categoryAdded: anAddedEvent
	| categoryName |
	categoryName := anAddedEvent item.
	^ 'Smalltalk organization addCategory: ''{1}''' format: {categoryName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:49:16.088'!
categoryRemoved: aRemovedEvent
	| categoryName |
	categoryName := aRemovedEvent item.
	^ 'Smalltalk organization removeCategory: ''{1}''' format: {categoryName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:50:29.154'!
categoryRenamed: aRenamedEvent

	^ 'Smalltalk organization renameCategory: ''{1}'' toBe: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName.}! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:52.584'!
changeExtension
	^ self extensionForSuffix: FileDirectory changeSuffix.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:24.896'!
classAdded: anAddedEvent
	^ self classAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:08.601'!
classAddedOrModified: anEvent
	| addedOrModifiedClass | 
	addedOrModifiedClass := anEvent item.
	^ addedOrModifiedClass definition.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:48:24.449'!
classModified: aModifiedEvent
	^ self classAddedOrModified: aModifiedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 19:26:21.287'!
classRecategorized: aRecategorizedEvent
	| aClass |
	aClass := aRecategorizedEvent item.
	^ '{1} category: ''{2}''' format: {aClass. aClass category}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:13:32.5'!
classRemoved: aRemovedEvent
	| removedClass | 
	removedClass := aRemovedEvent item.
	^ '{1} removeFromSystem' format: {removedClass name}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 17:24:47.292'!
classRenamed: aRenamedEvent

	^ '{1} rename: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 20:01:02.201'!
classReorganized: aReorganizedEvent
	| aClass |
	aClass := aReorganizedEvent item.
	^ '{1} do: [ :eachCategory | {2} organization addCategory: eachCategory ]'
		format: {aClass organization categories. aClass}! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 2/23/2010 13:49:48.655'!
createAndStartReplica
	self 
		createCopyOfThisImage;
		startReplicaInNewProcess! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:08:22.907'!
createCopyOfThisImage
	
	self deleteReplicaImage.
	
	self squeakFileExtensions do: [ :extension | 
		FileDirectory default
			copyFileNamed: self nameOfThisImage, extension 
			toFileNamed: self nameOfReplicaImage, extension. ].! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:09:31.959'!
deleteReplicaImage

	self squeakFileExtensions do: [ :extension | 
		FileDirectory default 
			deleteFileNamed: self nameOfReplicaImage, extension ifAbsent: [] ]! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:29:49.375'!
extensionForSuffix: aSuffix
	^ FileDirectory dot, aSuffix
	! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:47.418'!
imageExtension
	^ self extensionForSuffix: FileDirectory imageSuffix.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:10.971'!
methodAdded: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 13:35:06.984'!
methodAddedOrModified: anEvent
	| source sourceWithDoubleEscapedStrings |
	source := anEvent item getSource asString.
	sourceWithDoubleEscapedStrings := source copyReplaceAll: '''' with: ''''''.
	^ '{1} compile: ''{2}''' 
		format: {anEvent itemClass. sourceWithDoubleEscapedStrings}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:18.132'!
methodModified: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 12:50:29.172'!
methodRemoved: aRemovedEvent
	^ '{1} removeSelector: #{2}' 
		format: {aRemovedEvent itemClass. aRemovedEvent itemSelector}! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/26/2010 22:05:12.719'!
nameOfReplicaImage
	^ self nameOfThisImage, '-replicated-', self replicaName! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:57.122'!
nameOfThisImage
	| imageFilePath imageFileName |
	imageFilePath := SmalltalkImage current imageName.
	imageFileName := self workingDirectory localNameFor: imageFilePath.
	^ FileDirectory baseNameFor: imageFileName.	! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 18:40:52.767'!
parentProcessId
	^ ThisOSProcess thisOSProcess ppid.! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:24:46.072'!
replicaImageName
	^ self nameOfReplicaImage! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:32:03.545'!
replicaImagePath
	^ self workingDirectory fullNameFor: (self replicaImageName, self imageExtension)! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.519'!
replicaName
	^ replicaName! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.52'!
replicaName: anObject
	replicaName := anObject! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.076'!
replicaProcess
	^ replicaProcess! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.077'!
replicaProcess: anObject
	replicaProcess := anObject! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 21:30:34.71'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.275'!
servicePort
	^ servicePort! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.276'!
servicePort: anObject
	servicePort := anObject! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:31:15.856'!
squeakFileExtensions
	^ { self imageExtension. self changeExtension } ! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 3/2/2010 21:42:11.538'!
startReplicaInNewProcess
	| squeakVmPath |
	squeakVmPath := OSProcess programName.
	self replicaProcess: (
		ExternalOSProcess concreteClass 
			programName: squeakVmPath 
			arguments: { "'-headless'." self replicaImagePath. } 
			initialEnvironment: nil ).
	self replicaProcess value.! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 2/25/2010 10:56:34.6'!
stopReplicaAndCleanUp
	self class remove: self.
	self 
		stopReplicaProcess;
		deleteReplicaImage! !

!SReplicator methodsFor: 'start / stop' stamp: 'replica 2/24/2010 22:09:37.556'!
stopReplicaProcess
	self replicaProcess 
		ifNotNil: [ self replicaProcess terminate ].
	! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:41.204'!
workingDirectory
	^ FileDirectory default! !

CompiledMethod variableByteSubclass: #SInstrumentedMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 8/10/2010 15:26:16.334'!
activateBefore: methodIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := SWeavingInstrumentor extensionAtIndex: methodIndex.
	aMethodExtension codeSight csTestRunner activateTracing.! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.264'!
activationOn: aSelectorSymbol inClass: aClass
	| originalMethod decompiledMethodNode methodNode aroundCodeNode wrappedStatements statementToAdd instrumentedMethod originalStatements |
	
	originalMethod := aClass >> aSelectorSymbol.
	decompiledMethodNode := originalMethod decompile.
	decompiledMethodNode instVarNamed: 'properties' put: nil.
	methodNode := Parser new parse: decompiledMethodNode asString class: aClass.
	
	aroundCodeNode := self createActivationAroundCodeFor: originalMethod.
	wrappedStatements := aroundCodeNode "return" expr "ensure" receiver "block" statements. 
	
	originalStatements := methodNode body statements copy.
	methodNode body statements removeAll: originalStatements.
	
	originalStatements do: [  :st | 
		statementToAdd := (st isKindOf: ReturnNode) ifTrue: [ st expr ] ifFalse: [ st ] .
		wrappedStatements add: statementToAdd ].
	
	methodNode body statements addFirst: aroundCodeNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:47:12.281'!
createActivationAroundCodeFor: aCompiledMethod
	| extIndex aroundCode aroundCodeMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	aroundCode := 
		'^ [',
			'(' , SWeavingInstrumentor asString , ' calleeAtIndex: ' , extIndex asString , ')' ,
			'     codeSight activateTracing.',
		'] ensure: [',
			'(' , SWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
			'     codeSight deactivateTracing.',
		']'.
	
	aroundCodeMethodNode := Parser new parse: 'foo ', aroundCode class: Object.
	^ aroundCodeMethodNode body statements first! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:47:12.289'!
createTraceCallFor: aCompiledMethod
	| extIndex traceCallString tmpMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	traceCallString := 
		'(' , SWeavingInstrumentor asString , ' calleeAtIndex: ' , extIndex asString , ')' ,
		'     calledByRunningTestWithReceiver: self'.

	tmpMethodNode := Parser new parse: 'foo ' , traceCallString class: Object.
	^ tmpMethodNode body statements first! !

!SInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 8/10/2010 15:27:38.78'!
deactivateAfter: calleeIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := SWeavingInstrumentor extensionAtIndex: calleeIndex.
	aMethodExtension codeSight csTestRunner deactivateTracing.! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/5/2010 11:42:57.148'!
on: aSelectorSymbol inClass: aClass
	| originalMethod methodNode traceCallNode instrumentedMethod |
	
	originalMethod := aClass >> aSelectorSymbol.
	methodNode := self parseSource: originalMethod.
	
	traceCallNode := self createTraceCallFor: originalMethod.
	methodNode body statements addFirst: traceCallNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.325'!
parseSource: aCompiledMethod
	| source |
	source := aCompiledMethod getSource.
	^ Parser new parse: source class: aCompiledMethod methodClass.
	! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.15'!
clientMethod
	^ self originalMethod! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.162'!
compiledMethod
	^ self originalMethod! !

!SInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.218'!
install
	self methodClass addSelectorSilently: self selector withMethod: self.! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.173'!
methodExtension
	^ self originalMethod methodExtension! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.184'!
methodExtension: anObject
	^ self originalMethod methodExtension: anObject! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.195'!
originalMethod
	^ self properties at: #codeSightOriginalMethod ifAbsent: [ nil ]! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.207'!
originalMethod: aCompiledMethod
	self properties at: #codeSightOriginalMethod put: aCompiledMethod! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 7/5/2010 08:38:34.002'!
resetMethodExtension
	self methodExtension: nil! !

!SInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.229'!
uninstall
	(self methodClass includesSelector: self selector)
		ifTrue: [
			 self methodClass 
				addSelectorSilently: self selector 
				withMethod: self originalMethod. ]! !

TextAttribute subclass: #STextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Text'!

!STextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color
	^ color! !

!STextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color: anObject
	color := anObject! !

!STextBackgroundColor methodsFor: 'displaying' stamp: 'bs 12/21/2009 17:03'!
emphasizeBackground: bounds on: aCanvas
	aCanvas 
		fillRectangle: bounds
		color: self color.! !

!STextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/21/2009 17:34'!
shoutShouldPreserve
	^ true! !

!STextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 18:22'!
writeScanOn: strm
	! !

Actor subclass: #SActor
	instanceVariableNames: 'codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.096'!
codeSight
	^ codeSight! !

!SActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.097'!
codeSight: anObject
	codeSight := anObject! !

!SActor methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 21:20:59.344'!
recipient
	^ self codeSight! !

STbTestCase subclass: #SCstTestCase
	instanceVariableNames: 'registeredPackages unregisteredPackages tddAutoRunTestRunner codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

SCstTestCase subclass: #SAsyncExampleTest
	instanceVariableNames: ''
	classVariableNames: 'CollectedMessages'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:07'!
addMessage: aString
	self collectedMessages add: aString.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:43'!
backgroundExampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testRunExampleInBackground).
	^ aSuite.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:02'!
collectedMessages
	^ CollectedMessages ifNil: [CollectedMessages := OrderedCollection new.]! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:05'!
collectedMessagesAsString
	| stream |
	stream := WriteStream with: String new.
	self collectedMessages do: [: elem | stream nextPutAll: elem].
	^ stream contents! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:39'!
exampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testExample).
	^ aSuite.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:03'!
resetCollectedMessages
	CollectedMessages := nil.! !

!SAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:36'!
testExample
	self class addMessage: 'Hello'! !

!SAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:09.974'!
testRunExampleInBackground
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: (SAsyncExampleTest exampleSuite).! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight
	^ codeSight! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight: anObject
	codeSight := anObject! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 7/4/2010 12:48:15.208'!
codeSightClass
	^ SCodeSight! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 7/5/2010 10:34:10.059'!
createInstrumentor
	^ SInstrumentor wrapping! !

!SCstTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/9/2010 13:56:54.841'!
createSuperCallTestCode
	^ 'testSuperCall', String crlf, String tab, 'STbPersonSubclass new asString'.! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ self codeSight csTestRunner! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:40'!
instrumentor
	^ self codeSight instrumentor! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 7/12/2010 20:23:54.506'!
resetTbPackage
	self tbClasses do: [ :aClass | 
		aClass methodDict values do: [ :method | method resetMethodExtension ] ].! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 8/10/2010 18:42:12.34'!
runTbTests
	self runTestMethods: self tbTestMethods.! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 8/10/2010 18:38:47.762'!
runTestMethods: testMethods
	self csTestRunner runAndTraceTestMethods: testMethods.! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 8/11/2010 11:28:47.633'!
setUp
	super setUp.
	self resetTbPackage.
	
	self codeSight: self codeSightClass new.
	self tracePackage: self tbPackage.
	self csTestRunner tddAutoRunStart.! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 8/11/2010 11:26:40.908'!
tearDown
	self csTestRunner 
		tddAutoRunStop;
		disableRunningTestsInBackground.
	
	self codeSight cleanUp.
	self codeSight: nil.
	self resetTbPackage.
	super tearDown.! !

!SCstTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 11:27:18.337'!
tracePackage: aPackageInfo
	(self codeSight managedPackages includes: aPackageInfo)
		ifFalse: [ self codeSight addToManagedPackages: aPackageInfo ]! !

SCstTestCase subclass: #SDistributionRequestTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-DistributionTests'!

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:16.027'!
codeSightClass
	^ SCodeSightForDistributionRequestTests! !

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 15:25:33.704'!
testRequestForCoverageMaintenance
	| testMethodsToRun testMethodNames actor coverageData |
	testMethodsToRun := { self exampleTestMethod }.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self csTestRunner activateTracing.
	self codeSight maintainCoverage: testMethodNames.
	
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestCoverage isEmpty ].
	coverageData := actor receivedTestCoverage at: self exampleTestMethod qualifiedName.
	self should: [ (coverageData at: self exampleMethod qualifiedName) includes: STbPerson name ].
	! !

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.451'!
testRequestForTesting
	| testMethodsToRun testMethodNames actor |
	testMethodsToRun := STbPersonTest testMethods.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self codeSight runTests: testMethodNames.
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestResult passed isEmpty ].
	self shouldnt: [ actor receivedTestResult failures isEmpty ].! !

SCstTestCase subclass: #SDistributionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-DistributionTests'!

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/25/2010 08:27:21.659'!
createExampleCoverageData
	| testsToCoverageData coverageData | 
	testsToCoverageData := Dictionary new.
	coverageData := testsToCoverageData 
			at: self exampleTestMethod qualifiedName
			put: Dictionary new.
	coverageData 
		at: (self exampleMethod qualifiedName)
		put: {self exampleMethod methodClass name}.
	
	^ testsToCoverageData.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.459'!
createExampleTestResult
	| aTestResult |
	aTestResult := STestResult new.
	aTestResult addToPassed: (STbPersonTest selector: #testFirstnameAccessors).
	^ aTestResult.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 20:13:40.15'!
ensureCoverageOfExampleCode
	self runTbTests. ! !

!SDistributionTests methodsFor: 'running' stamp: 'bs 8/11/2010 14:16:39.4'!
setUp
	super setUp.
	self codeSight testReplicator: SReplicator basicNew.
	self codeSight testActorId: ActorIdMock new.
	self codeSight maintenanceReplicator: SReplicator basicNew.
	self codeSight maintenanceActorId: ActorIdMock new.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 20:15:50.861'!
testNonInstrumentation
	| aSubclass aSelector |
	
	self runTbTests.
	self should: [ (STbPerson >> #firstname) isMwMethodWrapper ].
	
	self codeSight turnOffStandaloneMode.
	self shouldnt: [ (STbPerson >> #firstname) isMwMethodWrapper ].
	
	self undoInTearDownDo: [
		aSubclass := self createExamplePersonSubclass.
		aSelector := aSubclass compile: self exampleMethodSource ].
	
	self shouldnt: [ (aSubclass >> aSelector) isMwMethodWrapper ].! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 14:19:01.296'!
testOpenEvents
	self codeSight makeDistributed.
	self assert: self codeSight openEvents isEmpty.
	self compileExampleMethod.
	self deny: self codeSight openEvents isEmpty.
	self assert: (self codeSight openEvents next isKindOf: SMethodModified)! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 16:32:27.674'!
testProcessingOfUpdates
	| aTestResult testsToCoverageData |
	self exampleMethod fixes: self exampleTestMethod.
	self codeSight makeDistributed.
	
	aTestResult := self createExampleTestResult.
	testsToCoverageData := self createExampleCoverageData.
	
	self csTestRunner reset.
	self compileExampleMethod.
	self should: [ self csTestRunner result passed isEmpty ].
	self shouldnt: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod hasFixedTestMethods ].
	
	self codeSight testResult: aTestResult.	
	self codeSight testResult: aTestResult testCoverage: testsToCoverageData.
	self shouldnt: [ self csTestRunner result passed isEmpty ]. 
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	
	self csTestRunner reset.
	self compileExampleMethod.
	self codeSight testResult: aTestResult.
	self codeSight testResult: aTestResult testCoverage: testsToCoverageData.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].! !

SCstTestCase subclass: #SEvolutionTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

SEvolutionTestCase subclass: #SFixedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 12/9/2009 16:57'!
charIntervalIn: codeString fromLine: from toLine: to
	| start end |
	self assert: [ codeString lineCount >= to and: [ codeString lineCount >= from ] ].
	start := 1.
	(1 to: (from - 1)) do: [:lineNo | 
		start := start + (codeString lineNumber: lineNo) size ].
	
	end := start.
	(to to: codeString lineCount) do: [:lineNo |
		end := end + (codeString lineNumber: lineNo) size ].
	
	^ (start to: end)! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:42:40.485'!
testRecompiling

	self runTbTests.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	(self exampleMethod) fixes: self exampleTestMethod.
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	self compileExampleMethod.
	self should: [ self exampleMethod hasCoveringTestMethods ]. 
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.957'!
testRefactoringVariations
	| code anExamplePerson variationWrapper selectionInterval |
	
	code := (STbPerson sourceCodeAt: #firstname) asString.
	selectionInterval := self charIntervalIn: code fromLine: 2 toLine: 2.
	self assert: [ code lineCount = 2 ].
	
	anExamplePerson := STbPerson new.
	anExamplePerson firstname: 'Paul'.
	self should: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper := SRefactoringVariationWrapper 
							on: #firstname 
							inClass: STbPerson 
							withCode: 'firstname'.
	
	variationWrapper installClosestToMethod.
	self deny: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper uninstall.! !

SCstTestCase subclass: #SFailedExpressionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.504'!
failingTestMethod
	^ STbPersonTest >> #testFailing! !

!SFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.496'!
testRecordingOfFailedExpression
	| source class selector |
	class := STbPersonTest. 
	source := 'testRecordingOfFailedExpression', String cr,  'self notExistingMethod'.
	self undoInTearDownDo: [
		selector := self installMethod: source inClass: STbPersonTest ].
	
	self assert: [ (class >> selector) failedExpressionInterval notNil ].
	self assert: [ (class >> selector) failedExpression = 'notExistingMethod' ].
	
	STbPersonTest compile: 'testRecordingOfFailedExpression', String cr.
	self assert: [ (class >> selector) failedExpressionInterval isNil ].! !

SCstTestCase subclass: #STddAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!STddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:32:16.839'!
createFooBarTestClass
	| aClass |
	aClass := TestCase subclass: #STbFooBarTest
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: self tbCategory.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass.! !

!STddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:34:45.551'!
createSubclassTestCode
	^ 'testFirstnameAccessorsForPersonAndAllSubclasses
			| aPerson aName |
			STbPerson withAllSubclassesDo: [:aPersonClass | 
			aPerson := aPersonClass new.
			aName := #Bastian asString.
			aPerson firstname: aName.
			self assert: aPerson firstname = aName. ]'! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.556'!
testAddAndChangeOfNonTestMethodsInTestClasses
	| selector |
	[	selector := #setUp.
		STbPersonTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty].
		STbPersonTest compile: selector, String crlf.
		STbPersonTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty]]
	ensure: [
		(STbPersonTest includesSelector: selector) 
			ifTrue: [STbPersonTest removeSelector: selector]].
	! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/10/2010 18:39:27.826'!
testAdditionAndRemovalOfOverriddenMethod
	| methodSelector testMethodSelector methodSource personsubclass |
	
	methodSelector := #asString.
	methodSource := (STbPerson >> methodSelector) clientMethod getSource.

	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: methodSource.
		testMethodSelector := self installMethod: self createSuperCallTestCode inClass: STbPersonTest ].
	
	self runTestMethods: {STbPersonTest >> testMethodSelector}.
	self shouldnt: [ (STbPerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	self undoInTearDownDo: [
		self removeMethod: (STbPerson >> methodSelector) ].
		
	self should: [ self csTestRunner result passed size = 1 ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	STbPerson compile: methodSource.
	self should: [ self csTestRunner result passed size = 1].
	self shouldnt: [ (STbPerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/10/2010 20:18:26.69'!
testAdditionAndRemovalOfSubclassesWithOverridingMethods
	| selector source subclass |
	STbPerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	selector := #firstname.
	source := STbPerson sourceCodeAt: selector.
	
	self undoInTearDownDo: [
		subclass := self createExamplePersonSubclass.
		self installMethod: self createSubclassTestCode inClass: STbPersonTest ].
	
	self runTbTests.
	self assert: 5 equals: self csTestRunner result passed size.
	self assert: 3 equals: (STbPerson >> #firstname) coveringTestMethods size.
	
	self csTestRunner reset.
	subclass compile: source.
	self assert: 3 equals: self csTestRunner result passed size.
	
	self csTestRunner reset.
	subclass removeSelector: selector.
	self assert: 1 equals: self csTestRunner result passed size.
	
	subclass compile: source.
	self csTestRunner reset.
	subclass removeFromSystem.
	self assert: 1 equals: self csTestRunner result passed size.! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/11/2010 10:36:19.523'!
testDistinguishingOfTestsHavingEqualHashes
	| failingCode1 failingMethod1 failingCode2 failingMethod2 |
	
	failingCode1 := 'testFailingTest1 self fail'.
	failingCode2 := 'testFailingTest2 self fail'.
	"test adding"
	self undoInTearDownDo: [
		failingMethod1 := self installMethod: failingCode1 inClass: STbPersonTest].
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod1 ] ] ].
	
	
	self undoInTearDownDo: [
		failingMethod2 := self installMethod: failingCode2 inClass: STbPersonTest].
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2 ] ] ].

	"test modification"
	self installMethod: failingCode1 inClass: STbPersonTest.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod1 ] ] ].

	self installMethod: failingCode2 inClass: STbPersonTest.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2 ] ] ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.607'!
testDontResetResultIfThereIsNothingToRun
	|source|
	self csTestRunner runSuite: STbPersonTest suite.
	self shouldnt: [self csTestRunner result passed = 0].
	
	source := ('fooBar', String crlf).
	self undoInTearDownDo: [
		self installMethod: source inClass: STbPerson.].
	self shouldnt: [self csTestRunner result passed = 0].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.572'!
testExecutionOfAddedTestMethod
	| source runTestCase aMethod |
	aMethod := STbPersonTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	STbPersonTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: STbPersonTest].
	self should: [runTestCase selector = aMethod selector].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/10/2010 20:15:29.16'!
testExecutionOfCoveringTestsAfterMethodChanged

	self tracePackage: self tbPackage.
	self runTbTests. 
	
	STbPerson compile: (STbPerson sourceCodeAt: #firstname:).
	self should: [self csTestRunner result passed isEmpty not]. 
	self should: [self csTestRunner result passed first isKindOf: STbPersonTest].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/11/2010 10:45:11.07'!
testExecutionOfFailedTestsAfterMethodAddedOrChanged
	| methodSelector appMethodSource method | 
	methodSelector := #firstname.
	appMethodSource := STbPerson sourceCodeAt: methodSelector.
	method := STbPerson >> methodSelector.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		self removeMethod: method].
	
	self runTbTests.
	self deny: [self csTestRunner result errors isEmpty].
	self should: [self csTestRunner result errors anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = #testFirstnameAccessors]]].
	
	STbPerson compile: appMethodSource.
	self should: [self csTestRunner result errors isEmpty].
	self deny: [self csTestRunner result passed isEmpty].
	self should: [self csTestRunner result passed first isKindOf: STbPersonTest].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/11/2010 07:41'!
testForEndlessLoopUsingDoForEachCoveredMethod

	"self csTestRunner testCasesToRun add: (CSExampleTest selector: #testFirstnameAccessors).
	self csTestRunner runOpenTestCasesInSuite."
	
	"original version that break a lot of stuff.
	 I assume that using 'self doForEachCoveredMethod' in another doForEach.. Block was not a good idea"
	"CSTestRunner >> #runOpenTestCasesInSuite
	| aSuite testMethod |
	
	aSuite := TestSuite new.
	
	self failedTestCases do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			anAppMethod fixes: aTestMethod.
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}] ].
	
	
	self testCasesToRun do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}]].
	
	self resetTestCasesToRun.
	
	aSuite tests ifNotEmpty: [
		self reset; runSuite: aSuite].
	
	self doForEachCoveredMethod: nil."
	! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 8/10/2010 20:14:50.998'!
testModificationOfClass
	| instVarName classVarName |
	instVarName := 'foobar'. 
	classVarName := 'Foobar'.
	self tracePackage: self tbPackage.
	self runTbTests.
	[	
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].

		STbPerson addInstVarName: instVarName.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
		
		STbPerson addClassVarName: classVarName.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods] ]
	ensure: [
		(STbPerson instVarNames includes: instVarName)
			ifTrue: [STbPerson removeInstVarName: instVarName].
		(STbPerson classVarNames includes: classVarName)
			ifTrue: [STbPerson removeClassVarName: classVarName]]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 8/9/2010 17:07:36.696'!
testModificationTestOfClass
	|instVarName|
	instVarName := 'foobar'.
	[	self instrumentor instrumentClass: STbPerson.
		STbPersonTest addInstVarName: instVarName.
		self assert: 2 equals: self csTestRunner result passed size.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods]]
	ensure: [
		(STbPersonTest instVarNames includes: instVarName)
			ifTrue: [STbPersonTest removeInstVarName: instVarName].
		self instrumentor uninstrumentClass: STbPerson]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 11:10'!
testRemovalOfFailedTestCase
	| selector testClass |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	selector := #testFooBar.
	self installMethod:  selector, String crlf, String tab, 'self fail.' inClass: testClass.
	
	self should: [self csTestRunner result failures notEmpty].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: testClass) and: [test selector = selector]]].
	
	testClass removeSelector: selector.
	self should: [self csTestRunner result failures isEmpty].
	self should: [self csTestRunner result errors isEmpty]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 4/23/2010 09:19:00.846'!
testRemovalOfFailedTestsAfterTestClassOrMethodRemoved
	| testClass fooBarSource testMethodSelector |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	fooBarSource := 'testFooBar', String crlf , String tab , 'self fail'.
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeSelector: testMethodSelector.
	self should: [ self csTestRunner result failures isEmpty ].
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeFromSystem.
	self should: [ self csTestRunner result failures isEmpty ].! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/8/2010 17:31'!
testRemovalOfTestClass
	|testClass testClassName|
	[	testClass := self createFooBarTestClass. 
		testClassName := testClass name.
		testClass compile: 'testFooBar', String crlf, String tab, 'self fail'.
		self should: [self csTestRunner result failures size = 1].
		testClass removeFromSystem.
		self should: [self csTestRunner result failures isEmpty]]
	ensure: [
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [testClass removeFromSystem]]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 8/10/2010 20:14:16.237'!
testRenamingOfClass
	|class oldName|
	[
		self runTbTests.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
		
		class := STbPerson.
		oldName := class name.
		STbPerson rename: (oldName, 'new').
		self should: [(class >> #firstname) hasCoveringTestMethods].]
	ensure: [
		class rename: oldName.
		self instrumentor uninstrumentClass: STbPerson]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.518'!
testRepro
	| aSuite |
	STbPerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	
	aSuite := TestSuite new.
	aSuite addTest: (STbPersonTest selector: #testFirstnameAccessors).
	self csTestRunner runSuite: aSuite.
	self should: [ self csTestRunner result passed size = 1 ]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 8/11/2010 10:23:28.129'!
testRunningOnlyModifiedTestMethod
	self runTbTests.
	self compileExampleTestMethod.
	self assert: 1 equals: self csTestRunner result tests size.! !

STddAutoRunTests subclass: #STestModificationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.682'!
testAddingTestMethod
	| source runTestCase aMethod |
	aMethod := STbPersonTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	STbPersonTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: STbPersonTest].
	self should: [runTestCase selector = aMethod selector].! !

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 12:17:29.194'!
testModifyingTestMethod
	| exampleTestMethodVersion1 coveringTestMethods |
	self should: [self csTestRunner result passed isEmpty].
	
	self compileExampleTestMethod.
	self shouldnt: [self csTestRunner result passed isEmpty].
	
	exampleTestMethodVersion1 := self exampleTestMethod.
	self compileExampleTestMethod.
	coveringTestMethods := self exampleMethod coveringTestMethods.
	self should: [coveringTestMethods includes: self exampleTestMethod].
	self shouldnt: [coveringTestMethods includes: exampleTestMethodVersion1].! !

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 12:16:24.049'!
testRemovingTestClassOrMethod
	| testClass testMethodSelector |
	
	self should: [self exampleMethod coveringTestMethods size = 0].
	
	self undoInTearDownDo: [ testClass := self createFooBarTestClass ].
	testMethodSelector := testClass compile: self exampleTestMethodSource.
	
	self should: [self csTestRunner result passed size = 1].
	self should: [self exampleMethod coveringTestMethods size = 1].
	
	testClass removeSelector: testMethodSelector.
	self should: [self exampleMethod coveringTestMethods size = 0].
	
	testClass compile: self exampleTestMethodSource.
	testClass removeFromSystem.
	
	self should: [self exampleMethod coveringTestMethods size = 0].
	! !

Object subclass: #ATddBenchmarker
	instanceVariableNames: 'packages methods coveredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 03:51'!
appMethods

	| class |
	^ self methods reject: [:ea |
		class := ea methodClass ifNil: [ea clientMethod searchForClass].
		class
			ifNil: [false]
			ifNotNil: [class inheritsFrom: TestCase]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/20/2009 03:38'!
classesOfPackages

	^ (packages gather: [:p | p classes]) asSet! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestClassesTimesPerMethodFrom: timeForEachTestClass

	| testClassesTimesPerMethod |
	testClassesTimesPerMethod := Dictionary new. "appMethod -> coveringTestClassesTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testClassesTimesPerMethod
			at: appMethod
			put: (self coveringTestClassesTimeFor: appMethod from: timeForEachTestClass)].
	^ testClassesTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestTimesPerMethodFrom: timeForEachTest

	| testTimesPerMethod |
	testTimesPerMethod := Dictionary new. "appMethod -> coveringTestMethodsTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testTimesPerMethod
			at: appMethod
			put: (self coveringTestMethodsTimeFor: appMethod from: timeForEachTest)].
	^ testTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 03:48'!
computeTimeForAllTestsFrom: timeForEachTest

	^ timeForEachTest values sum.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'bs 7/20/2010 22:54:27.825'!
computeTimeForEachTest

	| aTestRunner testClasses timeForEach |
	aTestRunner := SCoverageTestRunner new.
	testClasses := self testClassesOfPackages.
	timeForEach := Dictionary new.
	testClasses
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | | time |
					time := [aTestRunner runSuite: (testClass suiteWithSelectorsMatching: s)] timeToRun.
					timeForEach at: (testClass >> s) methodReference put: time]]
		displayingProgress: 'Running Tests (' , testClasses size asString, ' test classes)'.
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:11'!
computeTimeForEachTestClassFrom: timeForEachTest

	| timeForEach |
	timeForEach := Dictionary new.
	self testClassesOfPackages do: [:class | | methodsOfClass time |
		methodsOfClass := timeForEachTest keys select: [:m | m actualClass = class].
		time := methodsOfClass inject: 0 into: [:t :m | (timeForEachTest at: m) + t].
		timeForEach at: class put: time].
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestClassesTimeFor: appMethod from: timeForEachTestClass

	| testClasses |
	testClasses := (appMethod coveringTestMethods
		collect: [:ea | ea methodClass]
		thenSelect: [:ea | ea isObsolete not]) asSet.
	^ testClasses
		inject: 0
		into: [:sum :c | (timeForEachTestClass at: c) + sum].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestMethodsTimeFor: appMethod from: timeForEachTest

	^ appMethod coveringTestMethods
		inject: 0
		into: [:sum :m | (timeForEachTest at: m methodReference ifAbsent: [0"???"]) + sum].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'rkrk 9/20/2009 18:17'!
measureCoveringTimesForPackages: packageString

	^ String streamContents: [:stream |
		self 
			measureCoveringTimesForPackages: packageString 
			printOn: stream].
	! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 7/4/2010 12:47:14.296'!
measureCoveringTimesForPackages: packageString printOn: stream

	"^ #(coveringTestMethodsTime coveringTestClassesTime timeForRunningAllTestsAtEveryChange)"
	| timeForEachTest timeForEachTestClass timeForAllTests testClassesTimesPerMethod testTimesPerMethod coveredTestMethodsTimes coveredTestClassesTimes |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	packages do: [:p | SWrappingInstrumentor systemInstrumentor instrumentPackage: p].

	timeForEachTest := self computeTimeForEachTest.
	timeForEachTestClass := self computeTimeForEachTestClassFrom: timeForEachTest.
	timeForAllTests := self computeTimeForAllTestsFrom: timeForEachTest.
	testTimesPerMethod := self computeTestTimesPerMethodFrom: timeForEachTest.
	testClassesTimesPerMethod := self computeTestClassesTimesPerMethodFrom: timeForEachTestClass.

	"CSV style output
	appMethods,coveredMethods,coveredTestMethodsTimes average, coveredTestMethodsTimes median, coveredTestMethodsTimes min, coveredTestMethodsTimes max, coveredTestMethodsTimes sum, coveredTestClassesTimes avg, coveredTestClassesTimes median, coveredTestClassesTimes sum, timeForAllTests, timeForAllTests sum"
	coveredTestMethodsTimes := testTimesPerMethod values.
	coveredTestClassesTimes := testClassesTimesPerMethod values.
	stream
		print: self appMethods size; nextPut: $,;
		print: (self methodsCovered: self appMethods) size; nextPut: $,;
		print: (coveredTestMethodsTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestMethodsTimes median roundTo: 1); nextPut: $,;
		print: coveredTestMethodsTimes min; nextPut: $,;
		print: coveredTestMethodsTimes max; nextPut: $,;
		print: coveredTestMethodsTimes sum; nextPut: $,;
		print: (coveredTestClassesTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestClassesTimes median roundTo: 1); nextPut: $,;
		print: coveredTestClassesTimes sum; nextPut: $,;
		print: timeForAllTests; nextPut: $,;
		print: (self methodsCovered: self methods) size * timeForAllTests;
		cr.
		
	packages do: [:p |SInstrumentor systemInstrumentor uninstrumentPackage: p].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 7/20/2010 22:54:27.862'!
measureTestExecutionTimeForPackages: packageString

	| aTestSuite testClasses nRuns |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	"packages do: [:p | CSCoverageTracingWrapper registerPackage: p]."
	
	aTestSuite := TestSuite new.
	testClasses := self testClassesOfPackages.
	
	self testClassesOfPackages
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | aTestSuite addTest: (testClass selector: s)]].
			
	nRuns := 2.
	^ ([nRuns timesRepeat: [SCoverageTestRunner new runSuite: aTestSuite]] timeToRun / nRuns).
	! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
methods

	^ methods ifNil: [
		methods := self classesOfPackages gather: [:class |
			class methodDict values]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 04:16'!
methodsCovered: methodCol

	^ methodCol select: [:ea | ea hasCoveringTestMethods].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
testClassesOfPackages

	^ self classesOfPackages select: [:class |
		class inheritsFrom: TestCase].! !

Object subclass: #ATddMCAnalyzer
	instanceVariableNames: 'inspector methodVersionResult doAfterGathering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'bs 11/20/2009 15:42'!
printVersionDatesOfPackage: packageName

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: packageName
		thenDo: [:versionInfos |
			self halt.
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'rkrk 9/20/2009 00:57'!
printVersionDatesOfPackage: packageName inRepo: repo

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: {packageName}
		in: repo
		thenDo: [:versionInfos |
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.794'!
gatherVersionsOf: packageNames in: mcRepository thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld 
		newForPackagesNamed: packageNames
		inRepo: mcRepository.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.787'!
gatherVersionsOf: packageName thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.779'!
inspect: selector of: class in: packageName 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector 
		startInspectVersionsFor: selector
		in: class.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'nil' stamp: 'rkrk 9/20/2009 00:58'!
methodVersionResult

	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 00:24'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifFalse: [^ self].
	Transcript cr show: 'done'.
	doAfterGathering value: methodVersionResult.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2009 23:13'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #versionFound ifFalse: [^self].
	Transcript cr; show: 'Found ' , anObject asString.
	methodVersionResult add: anObject.! !

Object subclass: #ATddReceiverAnalyzer
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
getClassOf: method

	^ method methodClass ifNil: [method searchForClass].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:38'!
init

	stream := WriteStream on: ''.! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:29'!
isOverwritten: method

	"CompiledMethod>>overridingMethods does not work"
	^ (self overridingClasses: method) notEmpty! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:35'!
methodsNotOverwrittenIn: package

	^ ((package coreMethods collect: [:ea | ea compiledMethod]
		thenSelect: [:method | method hasCoveringTestMethods])
		reject: [:method | self isOverwritten: method])
		reject: [:method | (self getClassOf: method) allSubclasses isEmpty].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
overridingClasses: method

	^ (self getClassOf: method) allSubclasses select: [:ea |
		ea includesSelector: method selector].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 22:29'!
printTestsForOverwrittenMethodsWithAndWithoutReceiverIn: package

	"self printTestsForOverwrittenMethodsWithAndWithoutReceiverIn:
		(PackageInfo named: 'AweSOM')"
	| methods
	appMethodClass pureTestCount testCountReceiver allNoRecv allRecv stat |
	self init.
	methods := self methodsNotOverwrittenIn: package.
	methods do: [:appMethod |
		appMethodClass := self getClassOf: appMethod.
		pureTestCount := appMethod coveringTestMethods size.
		allNoRecv := allRecv := 0.
		"<for each subclass>"
		appMethodClass allSubclasses do: [:subclass |
			testCountReceiver := 0.
			"<for each coveringTest>"
			"<if subclass or any of its subclasses are
			included in receiverclasses of coveringTest --> count+1>"
			testCountReceiver := appMethod coveringTestMethods count: [:test | 
				stat := test statisticsForCoveredMethod: appMethod clientMethod.
				(stat receiverClasses includesAnyOf: subclass withAllSubclasses)].
			"----"
			allNoRecv := allNoRecv + pureTestCount.
			allRecv := allRecv + testCountReceiver.
			"print it"
			stream
				cr; nextPutAll: 'If method '; nextPutAll: appMethod selector;
				nextPutAll: ' would be added to '; nextPutAll: subclass name; space;
				print: pureTestCount; nextPutAll: '/'; print: testCountReceiver;
				nextPutAll: ' should run.'.
		].
		"print it again"
		stream
			cr; print: allRecv; nextPut: $/; print: allNoRecv;
			nextPut: $=;
			print: (allRecv isZero
				ifTrue: [0]
				ifFalse: [allRecv / allNoRecv * 100 asFloat]).
		Transcript show: stream contents.
	].! !

Object subclass: #ATddVersionLoader
	instanceVariableNames: 'repo versionFileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddVersionLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
loadVersionsNamed: versionNames from: mcRepository

	| fileNames |
	fileNames := versionNames collect: [:ea |
		(ea endsWith: '.mcz') ifTrue: [ea] ifFalse: [ea , '.mcz']].
	self new
		repo: mcRepository;
		versionFileNames: fileNames;
		loadAll;
		yourself.! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:46'!
loadAll

	| versions |
	versions := self versionFileNames collect: [:ea |
		repo loadVersionFromFileNamed: ea].
	versions do: [:ea | ea load].! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
repo: mcRepository

	repo := mcRepository! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:44'!
versionFileNames

	^ versionFileNames! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:43'!
versionFileNames: fileNames

	versionFileNames := fileNames! !

Object subclass: #CodeSightSarBuilder
	instanceVariableNames: 'zip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Install'!

!CodeSightSarBuilder class methodsFor: 'service' stamp: 'rkrk 11/27/2009 15:14'!
create

	"self create"
	^ self new create! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'bs 1/25/2010 10:19:49.792'!
addFiles

	| paths |
	paths := {self downloadLatestSwaUtilVersion.
	self downloadMethodWrapperMczs.
	self downloadLatestCodeSightVersion.
	self	downloadLatestCodeSightTestExamplesVersion} gather: [:ea |
		(ea isCollection and: [ea isString not]) ifTrue: [ea] ifFalse: [{ea}]]. "flatten"
	paths do: [:path | 
		zip addFile: path as: (path subStrings: '/\') last].! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 13:28'!
addPostScript

	zip addString: self postscript as: 'install/postscript'.! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 13:28'!
addPreamble

	zip addString: self preamble as: 'install/preamble'.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:12'!
create

	self
		createZip;
		addPreamble;
		addPostScript;
		addFiles;
		writeAndCloseZip.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 13:30'!
createZip

	zip := ZipArchive new.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightTestExamplesVersion

	^ self fromCodeSightRepoDownload: 'CodeSightTestExamples-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightVersion

	^ self fromCodeSightRepoDownload: 'CodeSight-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:57.281'!
downloadLatestSwaUtilVersion

	^ self fromSwaUtilitiesRepoDownload: 'SwaUtil-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:45'!
downloadMethodWrapperFromSqueakMap

	| squeakMap package |
	squeakMap := SMSqueakMap default.
	squeakMap objects ifNil: [
		squeakMap inspect.
		self error: 'There is a problem with the SqueakMap instance, inst var objects should be a dictionary but is nil. Please fix it and restart the build process!!'].
	package := squeakMap packageWithNameBeginning: 'MethodWrappers'.
	^ (SMInstaller forPackageRelease: package lastRelease)
		download;
		fullFileName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:59'!
downloadMethodWrapperMcz

	^ self fromCodeSightRepoDownload: 'MethodWrappers'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:30'!
downloadMethodWrapperMczs

	^ {self fromCodeSightRepoDownload: 'MethodWrappers-'. "newest"
	self fromCodeSightRepoDownload: 'Methodwrappers-rkrk.1'. "for non trunk images"}
	! !

!CodeSightSarBuilder methodsFor: 'default' stamp: 'rkrk 11/27/2009 15:14'!
filename

	^ 'CodeSight-' , Date today yyyymmdd , '.sar'! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromCodeSightRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/CodeSight'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromRepo: repoUrl download: packageOrVersionName

	| repo versionName filename mimeDoc |
	repo := MCHttpRepository
		location: repoUrl
		user: ''
		password: ''.
	versionName := repo allVersionNames detect: [:ea | ea startsWith: packageOrVersionName]. "assume latest first. Seems to work..."
	filename := versionName , '.mcz'.
	mimeDoc := (Url absoluteFromText:  (repo urlForFileNamed: filename)) retrieveContents.
	^ FileStream
		forceNewFileNamed: filename
		do: [:s | s binary. s nextPutAll: mimeDoc content. s fullName].! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:23.85'!
fromSwaUtilitiesRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 15:10'!
postscript

	^ 'CSCoverageTracingWrapper initialize'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:59.759'!
preamble

	^ String streamContents: [:s |
		s
			nextPutAll: self preambleSwaUtilInstall; cr;
			nextPutAll: self preambleMethodWrapperInstall; cr;
			nextPutAll: self preambleCodeSightInstall; cr;
			nextPutAll: self preambleCodeSightTestExamplesInstall; cr].! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 15:04'!
preambleCodeSightInstall

	^ '(self membersMatching: ''CodeSight-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:17'!
preambleCodeSightTestExamplesInstall

	^ '(self membersMatching: ''CodeSightTestExamples-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:45'!
preambleMethodWrapperInstall

	^ '"For trunk image choose newest version, for olde images choose 1.mcz"
	SystemVersion current highestUpdate <= 7179
		ifTrue: [self installMember: (self memberNamed: ''Methodwrappers-rkrk.1.mcz'')]
		ifFalse: [(self membersMatching: ''MethodWrappers-*.mcz'') do: [:ea |
					ea fileName ~= ''Methodwrappers-rkrk.1.mcz'' ifTrue: [
						self installMember: ea]]].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 03:01'!
preambleSWAUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:24.481'!
preambleSwaUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:15'!
writeAndCloseZip

	zip
		writeToFileNamed: self filename;
		close.! !

Object subclass: #DummyMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!DummyMonitor methodsFor: 'as yet unclassified' stamp: 'bs 1/16/2010 11:10'!
critical: aBlock
	^ aBlock value! !

Object subclass: #SCodeSight
	instanceVariableNames: 'instrumentor testRunner fixedMaintainer packageChooser isSystemInstance wasCleanedUp systemEventAnalyzer testActorId developmentActorId maintenanceActorId distributionMode managedPackages testReplicator maintenanceReplicator openEvents actor eventProcessors'
	classVariableNames: 'Instance Instances SourceCodeMonitor'
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SCodeSight class methodsFor: 'synchronizing' stamp: 'bs 1/25/2010 18:55:14.46'!
sourceCodeMonitor
	" SourceCodeMonitor := nil"
	^ SourceCodeMonitor ifNil: [ SourceCodeMonitor := DummyMonitor new ]! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 7/4/2010 12:48:08.022'!
actor
	actor ifNil: [ 
		actor := SActor new.
		actor codeSight: self ].
	^ actor! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 3/2/2010 22:37:44.467'!
addToManagedPackages: aPackageInfo
	self managedPackages add: aPackageInfo.
	^ self instrumentor instrumentPackage: aPackageInfo.! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:23'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self toolButtons collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:16'!
buildWith: aBuilder
	| windowSpec |
	windowSpec := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	
	^aBuilder build: windowSpec
	! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 8/11/2010 11:24:31.366'!
cleanUp
	(self wasCleanedUp)
		ifFalse: [
			self managedPackages do: [:ea | self removeFromManagedPackages: ea].
			self isSystemInstance ifTrue: [ self uninstallFromSystem ].
			self systemNotifier noMoreNotificationsFor: self.
			self csTestRunner cleanUp.
			self instrumentor cleanUp.
			self wasCleanedUp: true ]! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/4/2010 14:34'!
close
	self cleanUp! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 22:46:48.241'!
createExtensionBlock
	^ self csTestRunner createExtensionBlock! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 22:46:06.163'!
createWeavingInstrumentor
	^ SInstrumentor weavingAndCreateExtensionsWith: self createExtensionBlock.! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 22:46:01.014'!
createWrappingInstrumentor
	^ SInstrumentor wrappingAndCreateExtensionsWith: self createExtensionBlock.! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ testRunner! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner: anObject
	testRunner := anObject! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:53:31.317'!
developmentActorId
	^ developmentActorId 
		ifNil: [ developmentActorId := ActorId localhostPort: self developmentActorPort ]! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:49:48.69'!
developmentActorPort
	^ 12000! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:24:45.391'!
distributionMode
	^ distributionMode ifNil: [ distributionMode := false ]! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:12.178'!
distributionMode: aBoolean
	^ distributionMode := aBoolean.! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 16:04:24.505'!
eventProcessors
	^ eventProcessors ifNil: [eventProcessors := OrderedCollection new]! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 08:58'!
extent
	^ 200 @ 250! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 14:12'!
finalize
	self cleanUp! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 8/10/2010 17:16:29.376'!
fixedMaintainer
	^ fixedMaintainer! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 8/10/2010 17:16:29.382'!
fixedMaintainer: anObject
	fixedMaintainer := anObject! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/11/2010 16:28:02.898'!
handle: aSystemEvent affectedClass: aClass
	| sightEvent testMethodNames |
	(self isClassManaged: aClass)
		ifTrue: [ 
			sightEvent := self systemEventAnalyzer analyze: aSystemEvent.
			self preprocess: sightEvent.
			self runsDistributed
				ifFalse: [
					self process: sightEvent.
					self postprocess: sightEvent]
				ifTrue: [
					self openEvents nextPut: sightEvent.
					testMethodNames := sightEvent testsToRun collect: [:ea | ea qualifiedName].
					self testActorId runTests: testMethodNames.
					self maintenanceActorId maintainCoverage: testMethodNames]]! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 1/11/2010 10:09'!
handleClassEvent: anEvent
	self handle: anEvent affectedClass: anEvent item! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 3/2/2010 13:48:32.141'!
handleMethodEvent: anEvent
	self handle: anEvent affectedClass: anEvent itemClass! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 09:50:14.036'!
handleSystemEvent: anEvent
	self csTestRunner handleSystemEvent: anEvent.
	self runsDistributed ifTrue: [ self replicateModification: anEvent ].
	
	(anEvent itemKind == #class) ifTrue: [ self handleClassEvent: anEvent ].
	(anEvent itemKind == #method) ifTrue: [ self handleMethodEvent: anEvent ].! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 8/10/2010 17:18:34.065'!
initialize
	self csTestRunner: SCoverageTestRunner new.
	self csTestRunner addDependent: self.
	self fixedMaintainer: SFixedMaintainer new.
	
	self instrumentor: self createWrappingInstrumentor.
	self eventProcessors add: self instrumentor.
	
	self packageChooser: SPackageChooser new.
	self packageChooser codeSight: self.
	{ #class. #method. #protocol. #category } do: [ :itemKind |
		self systemNotifier notify: self ofSystemChangesOfItem: itemKind  using: #handleSystemEvent: ].
	
	"self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	self systemNotifier notify: self ofSystemChangesOfItem: #method  using: #handleMethodEvent:."! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 7/4/2010 12:48:36.078'!
installIntoSystem
	SInfo instance: (SRealInfo new codeSight: self; yourself).
	self csTestRunner addDependent: SInfo instance.
	self isSystemInstance: true
		
	
	! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 13:34'!
installUninstallLabel
	^ self isSystemInstance
		ifTrue: [ 'uninstall from system' ]
		ifFalse: [ 'install into system' ].! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:42.226'!
instrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor instrumentPackage: aPackageInfo ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor
	^ instrumentor! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor: anObject
	instrumentor := anObject! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 8/9/2010 17:09:55.838'!
isClassManaged: aClass
	^ self managedPackages includes: (self packageOfClass: aClass)! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:40'!
isSystemInstance
	^ isSystemInstance ifNil: [ isSystemInstance := false ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 2/25/2010 10:33:55.565'!
isSystemInstance: anObject
	isSystemInstance := anObject.
	self changed: #installUninstallLabel. ! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/3/2010 20:11'!
label
	^ 'CodeSight'! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 8/11/2010 16:30:49.862'!
maintainCoverage: testMethodNames
	| testMethodsToRun testsToCoverageData coverageData |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner runAndTraceTestMethods: testMethodsToRun.
	
	testsToCoverageData := Dictionary new.
	testMethodsToRun do: [ :testMethod | 
		coverageData := testsToCoverageData 
				at: testMethod qualifiedName
				put: Dictionary new.
		
		testMethod coveredMethodsStatistics keysAndValuesDo: [ :method :stats |
			coverageData 
				at: (method qualifiedName)
				put: (stats receiverClasses collect: [:ea | ea name ]) ] ].
		
	self developmentActorId 
		testResult: self csTestRunner result
		testCoverage: testsToCoverageData.! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 8/11/2010 15:22:10.79'!
maintenanceActorId
	^ maintenanceActorId! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 8/11/2010 14:06:35.439'!
maintenanceActorId: anActorId
	maintenanceActorId := anActorId! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:53:54.166'!
maintenanceActorPort
	^ 12007! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:23.295'!
maintenanceReplicator
	^ maintenanceReplicator! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:33.135'!
maintenanceReplicator: anObject
	maintenanceReplicator := anObject! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:33.709'!
makeDistributed
	self distributionMode: true
	! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:27.222'!
makeStandalone
	self distributionMode: false! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 09:50:03.578'!
managedPackages
	^ managedPackages ifNil: [ managedPackages := WeakSet new ]! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:13:53.811'!
modification: aCommandString
	Compiler evaluate: aCommandString! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/4/2010 14:38'!
open
	^ ToolBuilder open: self! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'replica 2/24/2010 17:46:37.084'!
openEvents
	^ openEvents ifNil: [ openEvents := SharedQueue2 new ]! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:15'!
openPackageChooser
	^ self packageChooser open! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:32'!
openTestDriver! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:15'!
openTestRunner
	^ self csTestRunner open! !

!SCodeSight methodsFor: 'distribution-ui' stamp: 'bs 2/23/2010 09:29:52.58'!
operationModeLabel
	^ self runsDistributed
		ifTrue: [ 'standalone mode' ]
		ifFalse: [ 'distribution mode' ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:37'!
packageChooser
	^ packageChooser! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:37'!
packageChooser: anObject
	packageChooser := anObject! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 8/9/2010 17:24:46.496'!
packageOfClass: aClass
	^ self instrumentor packageOfClass: aClass! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 16:10:10.621'!
postprocess: aSightEvent
	self eventProcessors reversed do: [:ea | ea postprocess: aSightEvent]! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 8/11/2010 15:45:08.864'!
postprocessOpenEventWhenComplete
	self openEvents peek isCompleted ifTrue: [self openEvents next]! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 16:09:29.106'!
preprocess: aSightEvent
	self eventProcessors do: [:ea | ea preprocess: aSightEvent]! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/11/2010 13:27:51.985'!
process: aSightEvent
	self eventProcessors do: [:ea | ea process: aSightEvent]! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 11:49:00.632'!
removeFromManagedPackages: aPackageInfo
	self managedPackages remove: aPackageInfo.
	^ self instrumentor uninstrumentPackage: aPackageInfo.! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/25/2010 10:58:56.703'!
replicateModification: aSystemEvent
	| command |
	command := self testReplicator handle: aSystemEvent.
	{ self testActorId. self maintenanceActorId } do: [ :actorId | 
		actorId modification: command ].! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/25/2010 10:59:26.695'!
resetOpenEvents
	^ openEvents := SharedQueue2 new! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 8/10/2010 18:26:03.291'!
runTests: testMethodNames
	| testMethodsToRun |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner runAndTraceTestMethods: testMethodsToRun.
	self developmentActorId testResult: self csTestRunner result copy.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/23/2010 13:54:13.983'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:45.798'!
runsDistributed
	^ self distributionMode! !

!SCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:24:18.858'!
runsStandalone
	self runsDistributed not! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:15.208'!
startActorOnPort: anInteger

	self actor startOn: anInteger.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:10.874'!
startDevelopmentActor
	self startActorOnPort: self developmentActorPort! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 8/11/2010 15:12:54.148'!
startMaintenanceActor
	self startReplicaActorOnPort: self maintenanceActorPort.
	self csTestRunner tddAutoRunStop.
	"self switchToWeavingInstrumentor."! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:38:55.908'!
startReplicaActorOnPort: anInteger
	
	Utilities setAuthorInitials: 'replica'.
	self actor startOn: anInteger.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 8/11/2010 15:04:22.282'!
startTestActor
	self startReplicaActorOnPort: self testActorPort.
	self eventProcessors removeAll.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:06.365'!
switchToDistributedMode
	self
		turnOffStandaloneMode;
		turnOnDistributedMode.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/23/2010 11:50:56.977'!
switchToStandaloneMode
	self 
		turnOffDistributedMode;
		turnOnStandaloneMode;
		makeStandalone.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 7/1/2010 10:18:31.561'!
switchToWeavingInstrumentor
	self uninstrumentCode.
	self instrumentor: self createWeavingInstrumentor.
	self instrumentCode.! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:42.907'!
systemEventAnalyzer
	^ systemEventAnalyzer ifNil: [ systemEventAnalyzer := SSystemEventAnalyzer new ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:47'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 17:25:07.008'!
tddAutoModeDisabled
	self eventProcessors
		remove: self fixedMaintainer;
		remove: self csTestRunner! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 17:18:50.497'!
tddAutoModeEnabled
	self eventProcessors 
		add: self csTestRunner;
		add: self fixedMaintainer! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 17:02:11.161'!
tddAutoModeToggled
	self csTestRunner isInTddAutoRunMode
		ifTrue: [self tddAutoModeEnabled]
		ifFalse: [self tddAutoModeDisabled]! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 8/11/2010 15:22:01.076'!
testActorId
	^ testActorId! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 8/11/2010 14:06:41.78'!
testActorId: anActorId
	testActorId := anActorId! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:49:39.406'!
testActorPort
	^ 12003! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:47.025'!
testReplicator
	^ testReplicator! !

!SCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:54.286'!
testReplicator: anObject
	testReplicator := anObject! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 8/11/2010 16:31:10.65'!
testResult: aTestResult
	self csTestRunner 
		result: aTestResult;
		updateResults;
		updateResultsInHistory.! !

!SCodeSight methodsFor: 'distribution-messages' stamp: 'bs 8/11/2010 16:30:05.08'!
testResult: aTestResult testCoverage: testsToCoverageData
	| aSightEvent aTestMethod |
	testsToCoverageData keysAndValuesDo: [ :aTestName :coverageData |
		aTestMethod := CompiledMethod fromQualifiedName: aTestName.
		coverageData keysAndValuesDo: [ :aMethodName :classSymbols | 
			aTestMethod 
				called: (CompiledMethod fromQualifiedName: aMethodName) unwrappedMethod
				receiverClasses: (classSymbols collect: [ :ea | Smalltalk classNamed: ea ]) ]
		].
	aSightEvent := self openEvents next.
	aSightEvent testResult: aTestResult.
	self postprocess: aSightEvent.! !

!SCodeSight methodsFor: 'distribution-ui' stamp: 'bs 2/23/2010 11:52:13.677'!
toggleOperationMode
	self runsDistributed
		ifTrue: [ self switchToStandaloneMode ]
		ifFalse: [ self switchToDistributedMode ].
	self changed: #operationModeLabel.! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 14:16'!
toggleSystemInstallation
	self isSystemInstance
		ifTrue: [ self uninstallFromSystem ]
		ifFalse: [ self installIntoSystem ].
		
	
	! !

!SCodeSight methodsFor: 'ui-building' stamp: 'bs 2/23/2010 09:03:40.812'!
toolButtons
	^ #(( 'Package Chooser' #openPackageChooser )
		( 'Test Runner' #openTestRunner )
		( 'Test Driver' #openTestDriver )
		( #installUninstallLabel #toggleSystemInstallation )
		( #operationModeLabel #toggleOperationMode ))! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 8/11/2010 15:29:59.59'!
turnOffDistributedMode
	self actor stop.
	self testActorId close.
	self testActorId: nil.
	self maintenanceActorId close.
	self maintenanceActorId: nil.
	self testReplicator stopReplicaAndCleanUp.
	self testReplicator: nil.
	self maintenanceReplicator stopReplicaAndCleanUp.
	self maintenanceReplicator: nil.
	self resetOpenEvents.! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:44:36.47'!
turnOffStandaloneMode! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 8/11/2010 15:21:49.789'!
turnOnDistributedMode
	| runningProcessId tmpTestReplicator tmpMaintenanceReplicator |
	tmpTestReplicator := (SReplicator newTestReplicaOnPort: self testActorPort).
	tmpMaintenanceReplicator := (SReplicator newMaintenanceReplicaOnPort: self maintenanceActorPort).
	
	runningProcessId := self runningProcessId.
	SmalltalkImage current snapshot: true andQuit: false.
	"check whether this is the process that created the replica"
	(runningProcessId == self runningProcessId) 
		ifTrue: [
			tmpTestReplicator createAndStartReplica.
			
			SmalltalkImage current snapshot: true andQuit: false.
			(runningProcessId == self runningProcessId) 
				ifTrue: [
					tmpMaintenanceReplicator createAndStartReplica.
					self testActorId: (ActorId localhostPort: self testActorPort).
					self testReplicator: tmpTestReplicator.
					self maintenanceActorId: (ActorId localhostPort: self maintenanceActorPort).
					self maintenanceReplicator: tmpMaintenanceReplicator.
					self startDevelopmentActor.
					self makeDistributed. ]
				ifFalse: [
					self startMaintenanceActor ] ]
		ifFalse: [
			self startTestActor ].! !

!SCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:44:51.8'!
turnOnStandaloneMode! !

!SCodeSight methodsFor: 'test info' stamp: 'bs 7/4/2010 12:48:24.636'!
uninstallFromSystem
	self csTestRunner removeDependent: SInfo instance.
	SInfo resetToZeroInfo.
	self isSystemInstance: false 
		
	
	! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:46.751'!
uninstrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor uninstrumentPackage: aPackageInfo ]! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 16:32:19.881'!
update: aSymbol
	(#tddAutoRunMode = aSymbol) ifTrue: [^ self tddAutoModeToggled].
	^ super update: aSymbol.! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 15:04'!
wasCleanedUp
	^ wasCleanedUp ifNil: [ wasCleanedUp := false ]! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 15:04'!
wasCleanedUp: aBoolean
	^ wasCleanedUp := aBoolean! !

SCodeSight subclass: #SCodeSightForDistributionRequestTests
	instanceVariableNames: 'distributionTestsDevelopmentActor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-DistributionTests'!

!SCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:57:09.767'!
developmentActorId
	^ self distributionTestsDevelopmentActor ! !

!SCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:18.663'!
distributionTestsDevelopmentActor
	^ distributionTestsDevelopmentActor 
		ifNil: [ distributionTestsDevelopmentActor := SDistributionTestsDevelopmentActor new ]! !

Object subclass: #SDistributionTestsDevelopmentActor
	instanceVariableNames: 'receivedTestResult receivedTestCoverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-DistributionTests'!

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.603'!
receivedTestCoverage
	^ receivedTestCoverage! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.605'!
receivedTestResult 
	^ receivedTestResult! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.607'!
testCoverage: coverageData
	receivedTestCoverage := coverageData! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.609'!
testResult: aTestResult
	receivedTestResult := aTestResult! !

Object subclass: #SFailedExpressionStyler
	instanceVariableNames: ''
	classVariableNames: 'RegisteredInstance'
	poolDictionaries: ''
	category: 'Sight-Cst-Text'!

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
initialize
	"self initialize"
	super initialize.
	self load.! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:33'!
load
	self registeredInstance: self new.
	SwaSourceTextStyler instance registerStyler: self registeredInstance.! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance
	^ RegisteredInstance! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance: anInstance
	^ RegisteredInstance := anInstance! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
unload
	SwaSourceTextStyler instance unregisterStyler: self registeredInstance.
	self registeredInstance: nil.! !

!SFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 7/4/2010 12:48:54.42'!
createFailedExpressionAttribute
	^ STextBackgroundColor new
		color: Color red darker;
		yourself! !

!SFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 12/31/2009 16:24'!
styleSource: aText of: aCompiledMethod
	| styledSourceText failedExpressionTextInterval |
	styledSourceText := aText.
	(aCompiledMethod isTestMethod and: [aCompiledMethod hasTestFailed])
		ifTrue: [
			failedExpressionTextInterval := aCompiledMethod failedExpressionInterval.
			styledSourceText 
				addAttribute: self createFailedExpressionAttribute
				from: failedExpressionTextInterval first
				to: failedExpressionTextInterval last ].
	^ styledSourceText.! !

Object subclass: #SFixedAnalyzer
	instanceVariableNames: 'package codeRevisionsCoverage installer filenames methodModificationsOverTime methodAdditionsOverTime fixedRelationshipOverTime fixedCoverageDeltas codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision
	^ self methodAdditionsOverTime at: revision! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision put: methodNames
	^ self methodAdditionsOverTime at: revision put: methodNames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 15:25:49.789'!
analyzeCoverageForVersion: aVersionNumber	
	self codeSight addToManagedPackages: self package.
	self csTestRunner activateTracing.
	self runAllTestsOfPackage.
	self csTestRunner deactivateTracing.
	self gatherCoverageDataAndStoreAsVersion: aVersionNumber.
	self codeSight removeFromManagedPackages: self package.
	! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzeCoverageOverTime
	| alreadyRunThrough |
	alreadyRunThrough := 0.
	self filenames withIndexDo: [:filename :index |
		(index > alreadyRunThrough) ifTrue: [
			Transcript cr; show: index asString, ' started ... '.
			self installer uninstallPackage.
			Transcript show: 'uninstalled ...'.
			self installer installFromCache: filename.
			Transcript show: 'installed ...'.
			self analyzeCoverageForVersion: index.
			Transcript clear. ] ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 11:23:37.678'!
analyzeFixedRelationshipsOverTime
	|  madeItRunInRevisions revision methodsAdded methodsModified madeItRun fixedTests previousRevision previousCoveringTestMethods coverageDifference previousMadeItRun newTests newlyCoveringTests notNewButNewlyCoveringTests newAndNewlyCoveringTests |
	
	madeItRunInRevisions := fixedRelationshipOverTime := Dictionary new.
	filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		revision := self codeRevisionsCoverage at: index.
		methodsAdded := self addedMethodsAt: index.
		methodsModified := self modifiedMethodsAt: index.
	
		madeItRun := madeItRunInRevisions at: index put: Dictionary new.
	 
		revision keysAndValuesDo: [:appMethod :coveringTestMethods |
			fixedTests := madeItRun at: appMethod put: Set new.
			(methodsAdded includes: appMethod)
				ifTrue: [
					fixedTests addAll: coveringTestMethods.
					"entweder ist der test neu, falls nicht, muss ich aber von einem verschieben von funktionalitt ausgehen" ]
				ifFalse: [
					newTests := nil. "all tests that are in new this revision"
					previousRevision := self codeRevisionsCoverage at: (index - 1).
					previousCoveringTestMethods := previousRevision at: appMethod.
					coverageDifference := coveringTestMethods difference: previousCoveringTestMethods.
					
					previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
					fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods).
					
					newlyCoveringTests := coveringTestMethods difference: previousCoveringTestMethods.
					notNewButNewlyCoveringTests := newlyCoveringTests difference: newTests.
					"von diesen - notNewButNewlyCoveringTests; 
					 alle tests, die vor der erstellung dieser methode schon existiert haben,
					 da mglicherweise ein verschieben von funktionalitt statt gefunden hat"
					
					(methodsModified includes: appMethod)
						ifTrue: [ 
							newAndNewlyCoveringTests := newlyCoveringTests intersection: newTests.
							fixedTests addAll: newAndNewlyCoveringTests ]
						"ifFalse: [
							previousCoveringTestMethods isEmpty
								ifTrue: [
									fixedTests addAll: coverageDifference ]
								ifFalse: [
									previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
									fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods) ].
						 	]."
				 	].
			]. 
		Transcript clear ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:35'!
analyzeForMethodModifications
	| modifiedMethodNames previousRevision currentRevision patch modifications |
	previousRevision := nil.
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		currentRevision := self installer readVersionFromCache: filename.
		modifiedMethodNames := self modifiedMethodsAt: index put: Set new.
		previousRevision ifNotNil: [
			patch := previousRevision package snapshot patchRelativeToBase: currentRevision snapshot.
			modifications := patch operations select: [:ea | ea isModification and: [ea obsoletion isMethodDefinition]].
			modifications do: [:ea | 
				modifiedMethodNames add: (ea obsoletion className, ' >> #', ea obsoletion selector) ] ].
		previousRevision := currentRevision.
		Transcript clear. ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 13:02'!
analyzeForMethodsAdded
	| coverage previousCoverage addedMethodNames |
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		coverage := self codeRevisionsCoverage at: index.
		(index = 1) 
			ifTrue: [ self addedMethodsAt: index put: coverage keys ]
			ifFalse: [
				previousCoverage := self codeRevisionsCoverage at: (index - 1).
				addedMethodNames := coverage keys reject: [:ea | previousCoverage includesKey: ea].
				self addedMethodsAt: index put: addedMethodNames ].
		Transcript clear. ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:41'!
analyzeModificationsOverTime

	self 
		analyzeForMethodModifications;
		analyzeForMethodsAdded.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzePackage: aPackageInfo
	package := aPackageInfo..
	self 
		fetchVersionsToLocalCache;
		analyzeCoverageOverTime;
		analyzeModificationsOverTime;
		analyzeFixedRelationshipsOverTime.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:12'!
analyzePackage: aPackageInfo asVersion: aVersionNumber
	
	package := aPackageInfo.
	
	self 
		instrumentPackage;
		runAllTestsOfPackage;
		uninstrumentPackage;
		gatherCoverageDataAndStoreAsVersion: aVersionNumber
	! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:35'!
classesAndMetaclasses
	^ package classes gather: [ :aClass | {aClass. aClass class} ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:08'!
codeRevisionsCoverage
	^ codeRevisionsCoverage ifNil: [ codeRevisionsCoverage := Dictionary new. ]
	! !

!SFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:15.181'!
codeSight
	codeSight 
		ifNil: [
			codeSight := SCodeSight new.
			codeSight instrumentor: codeSight createWeavingInstrumentor ].
	^ codeSight! !

!SFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:57:50.644'!
codeSight: anObject
	codeSight := anObject! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:14'!
computeFixedCoverageDeltas
	| deltasInRev coveringTests |
	self codeRevisionsCoverage keysAndValuesDo: [:revisionIndex :coverageInRev |
		deltasInRev := self fixedCoverageDeltas at: revisionIndex put: Dictionary new.
		(self fixedRelationshipAt: revisionIndex) keysAndValuesDo: [:appMethod :fixedTests | 
			coveringTests := coverageInRev at: appMethod.
			coveringTests ifNotEmpty: [
				deltasInRev at: appMethod put: (fixedTests size / coveringTests size) ].
	 	].
	].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/9/2010 14:42:03.151'!
deltas
	^ deltas ifNil: [deltas := Dictionary new.]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
fetchVersionsToLocalCache
	
	self filenames: self installer fetchVersionsToLocalCache.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames
	^ filenames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames: aCollection
	filenames := aCollection! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:44'!
fixedCoverageDeltas
	^ fixedCoverageDeltas ifNil: [fixedCoverageDeltas := Dictionary new.]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:49'!
fixedCoverageDeltasAvg
	| deltasRevisionAvg |
	deltasRevisionAvg := Dictionary new.
	self fixedCoverageDeltas keysAndValuesDo: [:revisionIndex :deltasInRev |
		deltasRevisionAvg at: revisionIndex put: (deltasInRev values sum / deltasInRev values size) asFloat ].
	^ deltasRevisionAvg.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:54'!
fixedRelationshipAt: revisionIndex
	^ self fixedRelationshipOverTime at: revisionIndex! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:55'!
fixedRelationshipAt: revisionIndex put: methodToFixedTestsDict
	^ self fixedRelationshipOverTime at: revisionIndex put: methodToFixedTestsDict.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:53'!
fixedRelationshipOverTime
	^ fixedRelationshipOverTime ifNil: [ fixedRelationshipOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:11'!
gatherCoverageDataAndStoreAsVersion: aVersionNumber
	| codeCoverage |
	codeCoverage := self codeRevisionsCoverage at: aVersionNumber put: Dictionary new.
	self nonTestMethods do: [ :aCompiledMethod |
		codeCoverage 
			at: (aCompiledMethod qualifiedName)
			put: (aCompiledMethod coveringTestMethods collect: [:ea | ea qualifiedName]) ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:27.451'!
installer 
	^ installer ifNil: [ installer := SMczInstaller newForPackageNamed: self package packageName ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:47:14.323'!
instrumentPackage
	
	SWrappingInstrumentor systemInstrumentor instrumentPackage: package.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:12'!
methodAdditionsOverTime
	^ methodAdditionsOverTime ifNil: [ methodAdditionsOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:11'!
methodModificationsOverTime
	^ methodModificationsOverTime ifNil: [ methodModificationsOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision
	^ self methodModificationsOverTime at: revision! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision put: methodNames
	^ self methodModificationsOverTime at: revision put: methodNames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:59'!
nonTestMethods
	^ self classesAndMetaclasses gather: [ :aClass | 
		aClass methodDict values reject: [:aCompiledMethod | 
			aCompiledMethod selector isTestSelector ] ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package
	^ package! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package: aPackageInfo
	package := aPackageInfo! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/20/2010 22:54:27.917'!
runAllTestsOfPackage	
	| aTestRunner aSuite |
	aTestRunner := SCoverageTestRunner new.
	aSuite := TestSuite new.
	self testClasses do: [ :aTestClass | 
		aTestClass selectors 
			select: [:ea | ea isTestSelector ] 
			thenDo: [:ea | aSuite addTest: (aTestClass selector: ea) ]].
	aTestRunner runSuite: aSuite.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:21'!
testClasses
	^ package classes select: [ :aClass | aClass inheritsFrom: TestCase ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:47:14.317'!
uninstrumentPackage
	
	SWrappingInstrumentor systemInstrumentor uninstrumentPackage: package.! !

Object subclass: #SInfo
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Sight-Cst-Browser'!

!SInfo class methodsFor: 'instance creation' stamp: 'bs 1/14/2010 12:45'!
do! !

!SInfo class methodsFor: 'system instance' stamp: 'bs 7/4/2010 12:49:00.417'!
instance
	"Instance := nil"
	^ Instance ifNil: [ Instance := SZeroInfo new ]! !

!SInfo class methodsFor: 'system instance' stamp: 'bs 1/14/2010 13:50'!
instance: anInfoObject
	Instance dependents do:  [ :ea | anInfoObject addDependent: ea ].
	Instance breakDependents.
	Instance := anInfoObject.
	Instance changed: #newTestResult.
	! !

!SInfo class methodsFor: 'tracing' stamp: 'bs 7/20/2010 15:58:52.301'!
mayClassMethodBeInstrumented: selector
	^ (#instance = selector) not! !

!SInfo class methodsFor: 'system instance' stamp: 'bs 7/4/2010 12:49:00.424'!
resetToZeroInfo
	" self resetToZeroInfo "
	self instance: SZeroInfo new.! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isActive
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
isRunning
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
openTestRunner
	self subclassResponsibility! !

!SInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
testResult
	self subclassResponsibility! !

SInfo subclass: #SRealInfo
	instanceVariableNames: 'codeSight isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Browser'!

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
codeSight
	^ codeSight! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:37'!
codeSight: anObject
	codeSight := anObject.! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
csTestRunner
	^ self codeSight csTestRunner! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:50'!
isActive
	^ true! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:47'!
isClassManaged: aClass
	^ self codeSight isClassManaged: aClass! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:03'!
isRunning
	^ isRunning ifNil: [ isRunning := false ]! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self codeSight openTestRunner! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:42'!
testResult
	^ self csTestRunner result! !

!SRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 12:56:32.951'!
update: aSymbol
	super update: aSymbol.
	(#(newTestResult startTestRun endTestRun) includes: aSymbol) ifFalse: [^ self].
	aSymbol = #startTestRun ifTrue: [isRunning := true].
	aSymbol = #endTestRun ifTrue: [isRunning := false].
	self changed: aSymbol.! !

SInfo subclass: #SZeroInfo
	instanceVariableNames: 'emptyTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Browser'!

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isActive
	^ false! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	^ false! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isRunning
	^ false! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self shouldNotImplement.! !

!SZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:55'!
testResult
	^ emptyTestResult ifNil: [ emptyTestResult := TestResult new ] ! !

Object subclass: #SMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!SMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #SMczInspectorOld
	instanceVariableNames: 'isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

SMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

SMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

!SMczInspectorOld class methodsFor: 'examples' stamp: 'bs 7/4/2010 12:48:25.966'!
exampleVersions
	| instance result repo |
	exampleCache ifNotNilDo: [ :c | ^ c ].
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'Xpf-CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames select: [ :filename | filename startsWith: 'Xpf-CodeTalk' ]) 
		do: 
			[ :filename | 
			instance zip: (SMczCache 
					cacheAt: filename
					ifNoneGetFrom: repo).
			instance loadVersionInfo.
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: 
				[ :bin | 
				
				[ (DataStream on: bin contentStream) next definitions 
					select: 
						[ :def | 
						def isMethodDefinition and: [ def className = 'XpfCodeTalk' and: [ def selector = #todo ] ] ]
					thenDo: 
						[ :def | 
						result add: (CSRemoteMethodVersion 
								repository: repo
								info: instance info
								definition: def) ] ] 
					on: Error
					do: 
						[ :fallThrough | 
						"Unknown content in snapshot.bin!!"
						 ] ] ]
		displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!SMczInspectorOld methodsFor: 'adding repos' stamp: 'rkrk 9/19/2009 19:04'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages
	to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
currentAncestors

	^ currentAncestors ifNil: [currentAncestors := Set new].! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 17:15'!
filenames
	| packageName aHttpRepository | 
	
	packageName := self repositories first value.
	aHttpRepository := self repositories first key.
	^ self
		filterFileNames: aHttpRepository readableFileNames
		packages: packageName.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 23:37'!
filterFileNames: someFileNames packages: somePackageNames

	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename |
		somePackageNames anySatisfy: [:name |
			self packageName: name matchesFileName: filename]].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:02'!
followAncestors

	^ followAncestors ifNil: [followAncestors := false].! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!SMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 22:53'!
inspectDefinitions

	| definition updateObject |
	definition := self reader definitions
		detect: [:def | def isMethodDefinition
			and: [classFilter = def actualClass]
			and: [selectorFilter = def selector]]
		ifNone: [^ self].
	lastDefinition = definition ifTrue: [^ self].
	updateObject := Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> definition.
		#info -> self reader info}.
	self changed: #matchingVersionFound with: updateObject.
	lastDefinition := definition.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 18:06'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames shouldInspectDefs |
	filenames := self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames.
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		self reader readFile: filename from: anHttpRepository.
		self inspectVersion.
		shouldInspectDefs := self followAncestors not
			or: [self currentAncestors isEmpty]
			or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]].
		shouldInspectDefs ifTrue: [self inspectDefinitions].
		self followAncestors ifTrue: [self updateCurrentAncestry]].! !

!SMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 19:29'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 19:36'!
inspectVersion

	self changed: #versionFound with: self reader info.! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!SMczInspectorOld methodsFor: 'testing' stamp: 'rkrk 9/19/2009 23:40'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInspectorOld methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:04'!
repositories

	^ repositories ifNil: [repositories := OrderedCollection new].! !

!SMczInspectorOld methodsFor: 'controlling' stamp: 'rkrk 9/19/2009 23:16'!
start

	process ifNotNil: [self stop].
	process := [
		[self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		] ensure: [
			self
				isRunning: false;
				changed: #done]
	] fork priority: 20.! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersions

	self
		followAncestors: true;
		start.! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self startInspectVersions.! !

!SMczInspectorOld methodsFor: 'controlling' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #SMczInstaller
	instanceVariableNames: 'repository packageName currentStep maxSteps currentAncestors reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/26/2009 10:14'!
newForPackageNamed: aString

	| aPackage instance repos httpRepo |
	aPackage := MCPackage named: aString.
	aPackage hasWorkingCopy ifFalse: [^ nil].
	repos := aPackage workingCopy repositoryGroup repositories.
	httpRepo := repos detect: [:r | r isKindOf: MCHttpRepository ].
	
	instance := self new.
	instance 
		repository: httpRepo;
		packageName: aPackage name.
	^ instance ! !

!SMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/20/2009 17:29'!
newForPackagesNamed: packageName inRepo: mcRepository

	| instance |
	instance := self new.
	instance
		repository: mcRepository;
		packageName: packageName.
	^ instance! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:36'!
cacheAt: aFileName

	^ self cacheDirectory readOnlyFileNamed: aFileName! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:35'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
fetchVersionsToLocalCache
	| filenames |
	filenames := (self filterFileNames: self repository readableFileNames).	
	filenames do: [:filename |	
		self reader readFile: filename from: self repository ].
	^ filenames! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
filterFileNames: someFileNames
	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename | self packageMatchesFileName: filename].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ result reversed! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:53:45.547'!
installFromCache: aFileName
	MczInstaller installStream: (self cacheAt: aFileName).! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:29'!
packageMatchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: self packageName) ifFalse: [^ false].
	fileName size = self packageName size ifTrue: [true].
	followingChar := fileName at: self packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName

	^ packageName! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName: aName

	^ packageName := aName! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:28'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/23/2009 21:36'!
readVersionFromCache: aFileName
	^ MCMczReader versionFromStream: (self cacheAt: aFileName)! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:28.112'!
reader
	^ reader ifNil: [ reader := SMczReader new ]! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository

	^ repository! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository: aHttpRepo
	repository := aHttpRepo.! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/21/2009 20:52'!
uninstallPackage
	
	(PackageInfo named: self packageName) classes do: [:aClass | aClass removeFromSystem ]! !

Object subclass: #SMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SMczReader commentStamp: 'mt 6/3/2009 11:04' prior: 0!
This is a simplified version of the McMczReader.!

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value := value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!SMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 16:59'!
definitions

	"if it does not work, look at loadDefinitions"
	^ definitions ifNil: [
		(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[definitions := (DataStream on: bin contentStream) next definitions]
				on: Error
				do: [:fallThrough | definitions := OrderedCollection new]]].! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!SMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!SMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:00'!
info

	^ info ifNil: [info := self extractInfoFrom: (self parseMember: 'version')]! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!SMczReader methodsFor: 'public' stamp: 'bs 7/4/2010 12:48:25.981'!
readFile: aFilename from: aRepository 
	self
		repository: aRepository;
		zip: (SMczCache 
				cacheAt: aFilename
				ifNoneGetFrom: aRepository)! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #SPackageChooser
	instanceVariableNames: 'list listSelections codeSight window packageSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
build
	^ ToolBuilder build: self new! !

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
initialize
	"CSTraceChooser initialize"
	self registerInToolsFlap! !

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
open
	^ self new open! !

!SPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTraceChooser build 'Test Traces' 'Choose your packages for test tracing.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!SPackageChooser methodsFor: 'ui-building' stamp: 'bs 8/6/2010 14:02:18.083'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec 
		model: self;
		label: 'Package Chooser';
		children: OrderedCollection new;
		closeAction: #close.
		
	listSpec := builder pluggableMultiSelectionListSpec new.
	listSpec 
		model: self;
		list: #list;
		getIndex: #packageSelected;
		setIndex: #packageSelected:;
		getSelectionList: #listSelectionAt:;
		setSelectionList: #listSelectionAt:put:;
		frame: (0@0corner: 1@0.8).
	windowSpec children add: listSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec
		model: self;
		label: 'Refresh';
		action: #refresh;
		frame: (0@0.8 corner: 1@1).
	windowSpec children add: buttonSpec.
	
	^builder build: windowSpec! !

!SPackageChooser methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:13'!
close
	window := nil! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight
	^ codeSight! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight: anObject
	codeSight := anObject! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
list
	^ list ifNil: [ list := self packageNamesSorted ]! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelectionAt: index
	^ self listSelections at: index! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 14:04:19.208'!
listSelectionAt: index put: isMarked
	| selectedPackage newValue successfullyRegistered | 
	selectedPackage := self packageAt: index.
	newValue := isMarked.
	isMarked 
		ifTrue: [
			successfullyRegistered := self registerPackage: selectedPackage.
			successfullyRegistered 
				ifFalse: [ newValue := isMarked not ] ]
		ifFalse: [ self unregisterPackage: selectedPackage ].
	self listSelections at: index put: newValue.
	self changed: #packageSelected.! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelections
	listSelections ifNil: [
		self list ifNotNil: [
			listSelections := Array new: self list size withAll: false.
			self list doWithIndex: [ :each :index |
				(self registeredPackages includes: each) ifTrue: [
					listSelections at: index put: true ]]]].
	^ listSelections! !

!SPackageChooser methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:13'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageAt: index
	| packageName |
	packageName := self list at: index.
	^ self packageNamed: packageName! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageNamed: aName
	^ PackageOrganizer default packageNamed: aName ifAbsent: [].! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageNamesSorted
	| packageNames criticalPackages |
	packageNames := PackageOrganizer default packages 
			collect: [ :packageInfo | packageInfo packageName ].
	
	criticalPackages := {'Collections'. 'CollectionsTests'.
								'Kernel'. 'KernelTests'.
								'Graphics'. 'GraphicsTests'.
								'ST80'. 'SUnit'. 'System' }.
	^ (packageNames reject: [:package | 
			criticalPackages anySatisfy: [:critical | 
				critical = package] ]) sort! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 8/6/2010 14:08:38.371'!
packageSelected
	^ packageSelected ifNil: [packageSelected := 0]! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 8/6/2010 14:03:55.978'!
packageSelected: anInteger
	packageSelected := anInteger.
	self changed: #packageSelected! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
refresh
	list := nil.
	listSelections := nil.! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 09:59:53.122'!
registerPackage: aPackage
	^ self codeSight addToManagedPackages: aPackage! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 10:00:39.835'!
registeredPackages
	^ self codeSight managedPackages! !

!SPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 10:00:25.812'!
unregisterPackage: aPackage
	^ self codeSight removeFromManagedPackages: aPackage! !

Object subclass: #SPartialTracingBenchmarker
	instanceVariableNames: 'packageToBenchmark codeSight coveredMethodTestTimes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:48:15.202'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := SCodeSight new.
	codeSight instrumentor: SWeavingInstrumentor new.
	codeSight instrumentor codeSight: codeSight.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!SPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 1/24/2010 15:02'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:15.188'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := SCodeSight new.
	codeSight instrumentor: codeSight createWeavingInstrumentor.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/24/2010 14:39'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:24:40.87'!
benchmarkPartialTracingTimes
	| result testTime activationInstr |
	self halt.
	self codeSight instrumentor instrumentPackage: self packageToBenchmark.
	result := IdentityDictionary new.
	testTime := nil.
	self coveredMethods withIndexDo: [ :m :index |
		Transcript show: index asString; cr.
		Transcript show: 'covering: ',  m coveringTestMethods size asString; cr.
		testTime :=
			(self codeSight instrumentor canInstrument: m selector inClass: m methodClass)
				ifFalse: [ (m coveringTestMethods collect: [ :tm | self coveredMethodTestTimes at: m ]) sum ]
				ifTrue: [
					[ activationInstr := SInstrumentedMethod activationOn: m selector inClass: m methodClass.
					activationInstr install.
					codeSight csTestRunner runAndTraceTestMethods: m coveringTestMethods.
					activationInstr uninstall. ] timeToRunWithoutGC ].
		result at: m put: testTime. ].
	codeSight instrumentor uninstrumentPackage: self packageToBenchmark.
	^ result.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:02.492'!
classesAndMetaclasses
	^ self packageToBenchmark classes flatCollect: [ :c | {c. c class} ]! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight
	^ codeSight! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight: anObject
	codeSight := anObject! !

!SPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 1/24/2010 15:45'!
collectAllTestMethods
	^ (self packageToBenchmark classes
		select: [ :c | c isTestCaseClass ])
			flatCollect: [ :c | c testMethods ] ! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.559'!
coveredMethodTestTimes
	^ coveredMethodTestTimes! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.56'!
coveredMethodTestTimes: anObject
	coveredMethodTestTimes := anObject! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:54.897'!
coveredMethods
	^ self nonTestMethods select: [ :m | m hasCoveringTestMethods ].! !

!SPartialTracingBenchmarker methodsFor: 'initialize-release' stamp: 'bs 7/4/2010 12:48:15.195'!
initialize
	super initialize.
	self codeSight: SCodeSight new.
	self codeSight instrumentor: self codeSight createWeavingInstrumentor.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:23.258'!
nonTestMethods
	^ (self classesAndMetaclasses flatCollect: [ :c | c methodDict values ]) select: [ :m | m isTestMethod not ].! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:05'!
packageToBenchmark
	^ packageToBenchmark! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:01'!
packageToBenchmark: anObject
	packageToBenchmark := anObject! !

!SPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 8/10/2010 18:24:11.251'!
runAndTraceAllTests
	self codeSight csTestRunner
		runAndTraceTestMethods: self collectAllTestMethods.! !

Object subclass: #SReplicateMessage
	instanceVariableNames: 'command headerBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicateMessage class methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:47:20.627'!
receiveFrom: aSocket
	^ self new 
		receiveFrom: aSocket;
		yourself! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/8/2010 20:15:20.805'!
applyCommand
	Compiler evaluate: self commandAsString.! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command
	^ command! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command: anObject
	command := anObject! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 13:08:26.15'!
commandAsString
	^ self command! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:30.074'!
headerBytes
	^ headerBytes ifNil: [headerBytes := ByteArray new: self numberOfHeaderBytes]! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:20.283'!
numberOfHeaderBytes
	^ 4.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:37:46.473'!
receiveFrom: aSocket
	| bytesToRead bytesOfCommandString |
	bytesToRead := self receiveMessageLengthHeader: aSocket.
	bytesOfCommandString := ByteArray new: bytesToRead.
	aSocket receiveDataInto: bytesOfCommandString.
	self command: bytesOfCommandString asString.
	Transcript show: 'received command: ', self commandAsString; cr.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:36:12.351'!
receiveMessageLengthHeader: aSocket

	aSocket receiveDataInto: self headerBytes.
	^ self headerBytes unsignedLongAt: 1 bigEndian: true.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:59:14.146'!
sendOn: aSocket
	| commandString |
	commandString := self commandAsString.
	self headerBytes unsignedLongAt: 1 put: (commandString byteSize) bigEndian: true.
	aSocket sendData: self headerBytes, commandString asByteArray! !

Object subclass: #SStepper
	instanceVariableNames: 'blockToExecute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
executeInNextStep: aBlock
	blockToExecute := aBlock.
	ActiveWorld startStepping: self at: Time millisecondClockValue selector: #step arguments: nil stepTime: nil.! !

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:02'!
shouldGetStepsFrom: aWorld
	^ActiveWorld == aWorld! !

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
step
	blockToExecute value.
	ActiveWorld stopStepping: self selector: #step.! !

Object subclass: #SSystemEventMock
	instanceVariableNames: 'item kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
item
	^ item! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
item: anObject
	item := anObject! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:57'!
kind
	^ kind! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:57'!
kind: anObject
	kind := anObject! !

!SSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
oldItem
	^ item! !

Object subclass: #STestStatistic
	instanceVariableNames: 'receiverClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!STestStatistic class methodsFor: 'tracing' stamp: 'bs 7/20/2010 15:32:34.148'!
mayMethodBeInstrumented: aSelector
	^ false
	! !

!STestStatistic methodsFor: 'initialize-release' stamp: 'bs 10/28/2009 15:19'!
addCallInDepth: aNumber
	self flag: #rkrk. "for benchmarking"! !

!STestStatistic methodsFor: 'public' stamp: 'bs 8/11/2010 13:36:05.338'!
addReceiverClass: aClass
	self pvtReceiverClasses add: aClass.! !

!STestStatistic methodsFor: 'public' stamp: 'bs 8/11/2010 13:36:11.022'!
addReceiverClasses: classes
	self pvtReceiverClasses addAll: classes.! !

!STestStatistic methodsFor: 'as yet unclassified' stamp: 'bs 10/28/2009 15:18'!
printOn: stream

	stream
		nextPutAll: 'CSTestStatistic<Trace:';
		nextPutAll: 'Receivers:';
		print: self receiverClasses;
		nextPut: $>.! !

!STestStatistic methodsFor: 'accessing' stamp: 'bs 8/11/2010 13:35:35.319'!
pvtReceiverClasses
	^ receiverClasses 
		ifNil: [receiverClasses := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!STestStatistic methodsFor: 'accessing' stamp: 'bs 8/11/2010 13:35:54.211'!
receiverClasses
	^ self pvtReceiverClasses asIdentitySet! !

TestRunner subclass: #SCoverageTestRunner
	instanceVariableNames: 'isInTddAutoRunMode runsTestsInBackground modifiedMethods window runningTestMethod isActive'
	classVariableNames: 'RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

SCoverageTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

SCoverageTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

!SCoverageTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 15:28'!
initialize
	"CSTestRunner initialize"
	self registerInWorldMenu; registerInToolsFlap.! !

!SCoverageTestRunner class methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:13:03.865'!
mayMethodBeInstrumented: aSelector
	^ (#(#isTracingActivated #runningTestMethod) includes: aSelector) not! !

!SCoverageTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 7/20/2010 22:54:27.815'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( #SCoverageTestRunner build 'CodeSight Test Runner' 'A production scale test-runner for XP Forums.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!SCoverageTestRunner class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:33'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'CodeSight Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!SCoverageTestRunner class methodsFor: 'synchronizing' stamp: 'test 9/17/2009 23:32'!
resetSourceCodeAccessMonitor
	^ RunInBackgroundMonitor := nil! !

!SCoverageTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/14/2009 10:50'!
sourceCodeAccessMonitor
	^ RunInBackgroundMonitor ifNil: [ RunInBackgroundMonitor := Monitor new ]! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 8/10/2010 15:21:37.446'!
activateTracing
	isActive := true! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:02'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		layout: #vertical;
		children: {
			self buildButtonsWith: aBuilder.
			self buildTddControlButtonsWith: aBuilder
			};
		yourself.! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:18'!
buildTddControlButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self tddFlags collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:16'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.84 );
				yourself);				
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.84 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.84);
				yourself);
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.84 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	^ aBuilder build: window.! !

!SCoverageTestRunner methodsFor: 'initialize-release' stamp: 'replica 5/10/2010 17:51:44.951'!
cleanUp

	self
		disableRunningTestsInBackground;
		tddAutoRunStop;
		reset.! !

!SCoverageTestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:15'!
close
	window := nil! !

!SCoverageTestRunner methodsFor: 'system event handling' stamp: 'bs 7/20/2010 23:23:05.944'!
coverageEventHandler
	^ SCoverageEventHandler new
		coverageTestRunner: self;
		yourself! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 19:09:55.445'!
createExtensionBlock
	^ [ :aMethod | 
		aMethod isTestMethod
			ifTrue: [ STestMethodExtension new ]
			ifFalse: [ 
				SNonTestMethodExtension new
					coverageTestRunner: self;
					yourself ]  ]! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 8/10/2010 15:21:46.415'!
deactivateTracing
	isActive := false! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 4/30/2009 12:09'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self debugTest: each ].! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 7/20/2010 18:08:54.481'!
debugTest: aTestCase
	self withCurrentTest: aTestCase selectedMethod
		 do: [aTestCase debug]! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 1/1/2010 22:40'!
defectTestMethods
	^ self result defectTestMethods! !

!SCoverageTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
disableRunningTestsInBackground
	^ runsTestsInBackground := false! !

!SCoverageTestRunner methodsFor: 'private' stamp: 'bs 1/5/2010 15:30'!
disableTddAutoRunMode
	self isInTddAutoRunMode: false.! !

!SCoverageTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
enableRunningTestsInBackground
	^ runsTestsInBackground := true! !

!SCoverageTestRunner methodsFor: 'private' stamp: 'bs 1/5/2010 15:30'!
enableTddAutoRunMode
	self isInTddAutoRunMode: true.! !

!SCoverageTestRunner methodsFor: 'system event handling' stamp: 'bs 7/20/2010 23:23:15.907'!
handleSystemEvent: anEvent
	self coverageEventHandler handle: anEvent.! !

!SCoverageTestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:16'!
instrumentor
	^ self codeSight instrumentor! !

!SCoverageTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/11/2009 14:52'!
isInTddAutoRunMode
	^ isInTddAutoRunMode ifNil: [isInTddAutoRunMode := false].! !

!SCoverageTestRunner methodsFor: 'private' stamp: 'bs 8/10/2010 16:26:36.306'!
isInTddAutoRunMode: aBoolean
	isInTddAutoRunMode := aBoolean.
	self changed: #tddAutoRunMode.
	self changed: #tddAutoRunModeLabel! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 8/10/2010 15:21:13.106'!
isTracingActivated
	^ isActive ifNil: [isActive := false]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'mab 4/2/2009 20:33'!
label
	^ 'CodeSight Test Runner'! !

!SCoverageTestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:14'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'bs 8/10/2010 15:35:33.929'!
postprocess: aSightEvent
	! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'bs 8/11/2010 10:45:06.702'!
preprocess: aSightEvent

	aSightEvent addTestsToRun: (
		aSightEvent addedMethods select: [:ea | ea isTestMethod]).

	aSightEvent affectedMethods ifNotEmpty: [
		aSightEvent 
			addTestsToRun: (aSightEvent affectedMethods 
				flatCollect: [:ea | ea coveringTestMethods]);
			addTestsToRun: self defectTestMethods ].
	
	aSightEvent testsToRun
		do: [:ea | ea resetCoveredMethodsStatistics].
	
	aSightEvent removedMethods
		select: [:ea | ea isTestMethod]
		thenDo: [:ea | self testMethodRemoved: ea].

	"selector := self newMethod selector.
	methodClass := self newMethod methodClass.
	
	withTracingWrapper := CSWithTracingWrapper 
			on: selector inClass: methodClass inContext: aTestRunner codeSight.
	withTracingWrapper install. "! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'bs 8/11/2010 10:24:45.641'!
process: aSightEvent
	self runAndTraceTestMethods: aSightEvent testsToRun.
	aSightEvent testResult: self result.! !

!SCoverageTestRunner methodsFor: 'actions' stamp: 'bs 8/10/2010 17:24:43.525'!
reset
	self result: STestResult new; updateResults.! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:18:47.78'!
resetRunningTestMethod
	runningTestMethod := nil! !

!SCoverageTestRunner methodsFor: 'accessing' stamp: 'bs 9/10/2009 13:58'!
resetTestCasesToRun
	^ testCasesToRun := nil.! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 8/10/2010 18:23:38.226'!
runAndTraceTestMethods: testMethods
	| aSuite |
	testMethods ifNotEmpty: [
		self reset.
		aSuite := TestSuite new.
		aSuite addTests: (testMethods collect: [:ea | ea newTestCase]).
		self activateTracing.
		self runSuite: aSuite.
		self deactivateTracing. ].! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 8/10/2010 20:51:39.296'!
runSuite: aSuite 
	| runSuiteSynchronized |
	runSuiteSynchronized := [	
		SCoverageTestRunner sourceCodeAccessMonitor critical: [
			self changed: #startTestRun.
			super runSuite: aSuite.
			self updateResultsInHistory.
			self changed: #endTestRun]].

	(self runsTestsInBackground and: [
			ProcessBrowser isUIProcess: Processor activeProcess])
		ifTrue: [ runSuiteSynchronized forkAt: Processor userBackgroundPriority ]
		ifFalse: [ runSuiteSynchronized value ]! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 8/10/2010 20:51:54.68'!
runTest: aTestCase
	self withCurrentTest: aTestCase selectedMethod
		 do: [super runTest: aTestCase.
			 self changed: #newTestResult with: result].
	
	! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:10:15.655'!
runningTestMethod
	^ runningTestMethod! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:18:35.664'!
runningTestMethod: aCompiledMethod
	runningTestMethod := aCompiledMethod! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:11'!
runningTestsInBackgroundLabel
	^ self runsTestsInBackground
		ifTrue: [ 'DisableRunningTestsInBackground' ]
		ifFalse: [ 'EnableRunningTestsInBackground' ]! !

!SCoverageTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:17'!
runsTestsInBackground
	^ runsTestsInBackground ifNil: [runsTestsInBackground := false]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:06'!
tddAutoRunModeLabel
	^ self isInTddAutoRunMode 
		ifTrue: [ 'Stop Tdd Auto Run Mode' ]
		ifFalse: [ 'Start Tdd Auto Run Mode' ]! !

!SCoverageTestRunner methodsFor: 'auto run mode' stamp: 'bs 1/14/2010 13:57'!
tddAutoRunStart
	(self isInTddAutoRunMode)
		ifFalse: [
			self enableTddAutoRunMode ]! !

!SCoverageTestRunner methodsFor: 'auto run mode' stamp: 'bs 1/14/2010 13:57'!
tddAutoRunStop
	(self isInTddAutoRunMode)
		ifTrue: [
			self disableTddAutoRunMode ]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:03'!
tddFlags
	^ #(( #tddAutoRunModeLabel #toggleTddAutoRunMode )
		( #runningTestsInBackgroundLabel #toggleRunningTestsInBackground )).! !

!SCoverageTestRunner methodsFor: 'system event handling' stamp: 'bs 8/6/2010 11:54:55.987'!
testMethodModifiedFrom: oldTestMethod to: currentTestMethod
	oldTestMethod resetCoveredMethodsStatistics.! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'bs 8/8/2010 20:37:00.219'!
testMethodRemoved: aTestMethod
	aTestMethod resetCoveredMethodsStatistics.
	self result removeIfPresent: aTestMethod.! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:21'!
toggleRunningTestsInBackground
	self runsTestsInBackground
		ifTrue: [ self disableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]
		ifFalse: [ self enableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:07'!
toggleTddAutoRunMode
	self isInTddAutoRunMode 
		ifTrue: [ self tddAutoRunStop. self changed: #tddAutoRunModeLabel. ]
		ifFalse: [ self tddAutoRunStart. self changed: #tddAutoRunModeLabel. ]! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 3/3/2010 09:01:30.036'!
updateResultsInHistory
	(TestResult includesSelector: #updateResultsInHistory) 
		ifTrue: [ self result updateResultsInHistory ].! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 7/20/2010 22:58:41.06'!
withCurrentTest: aTestMethod do: aBlock
	self runningTestMethod: aTestMethod.
	aTestMethod resetCoveredMethodsStatistics.
	aBlock value.
	self resetRunningTestMethod.
	! !

MwMethodWrapper subclass: #SRefactoringVariationWrapper
	instanceVariableNames: 'variationMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 22:59'!
initialize
	"self initialize"
	super initialize! !

!SRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 22:14:46.852'!
on: aSelectorSymbol inClass: aClass withCode: sourceCodeString
	| wrapper variationAst |
	wrapper := super on: aSelectorSymbol inClass: aClass.
	variationAst := Compiler new 
						compile: sourceCodeString in: aClass
						notifying: nil
						ifFail: [].
	wrapper variationMethod: (variationAst generateUsing: aClass).
	^ wrapper! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 23:00'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	^ self variationMethod valueWithReceiver: anObject arguments: anArrayOfObjects.! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 10:02:28.155'!
variationMethod
	^ variationMethod! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 10:02:18.259'!
variationMethod: aCompiledMethod
	variationMethod := aCompiledMethod! !
SReplicator initialize!
SFailedExpressionStyler initialize!
SPackageChooser initialize!
SCoverageTestRunner initialize!
SRefactoringVariationWrapper initialize!
